c
c This file contains routines that substitute the helas calls for the quartic-vector-boson
c couplings with anomalous couplings.
c

      subroutine wwaa_anomal8(wm,a1,wp,a2, wwaa)
c
c This subroutine computes the wwaa-vertex with anomalous couplings
c     
      implicit none
      double complex wp(6),wm(6),a1(6),a2(6),wwaa, dotcc, dotrc
      double precision pwp(0:3),pwm(0:3),pa1(0:3),pa2(0:3), dotrr
      double precision cos2w, g1, cosw, sinw
      integer i
      external dotcc, dotrc, dotrr

#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/an_couplings.inc"   

      cos2w = 1.0d0 - sin2w
      cosw = sqrt(cos2w)
      sinw = sqrt(sin2w)
      g1 = ee / cosw

      pwm(0) = dble( wm(5))
      pwm(1) = dble( wm(6))
      pwm(2) = dimag(wm(6))
      pwm(3) = dimag(wm(5))
      pwp(0) = dble( wp(5))
      pwp(1) = dble( wp(6))
      pwp(2) = dimag(wp(6))
      pwp(3) = dimag(wp(5))
      pa1(0) = dble( a1(5))
      pa1(1) = dble( a1(6))
      pa1(2) = dimag(a1(6))
      pa1(3) = dimag(a1(5))
      pa2(0) = dble( a2(5))
      pa2(1) = dble( a2(6))
      pa2(2) = dimag(a2(6))
      pa2(3) = dimag(a2(5))

      wwaa = gwwa**2 * (dotcc(wm,a1)*dotcc(wp,a2) + dotcc(wm,a2)*dotcc(wp,a1) - 2.0d0*dotcc(wm,wp)*dotcc(a1,a2))

      if (ft0 .ne. 0) then
        wwaa = wwaa + ft0 * 8. * gw**4 * sin2w * ( dotrc(pwp,wm)*dotrc(pwm,wp) - dotcc(wp,wm)*dotrr(pwp,pwm) ) * 
     &   ( dotrc(pa1,a2)*dotrc(pa2,a1) - dotcc(a1,a2)*dotrr(pa1,pa2) )
      endif

      if (ft1 .ne. 0) then
        wwaa = wwaa + ft1 * 4. * gw**4 * sin2w * 
     &   ( dotrc(pa1,wm)*dotrc(pa2,wp)*dotrc(pwp,a2)*dotrc(pwm,a1) - dotrc(pa1,wm)*dotcc(a2,wp)*dotrr(pa2,pwp)*dotrc(pwm,a1) 
     &   + dotrc(pa1,wp)*dotrc(pa2,wm)*dotrc(pwp,a1)*dotrc(pwm,a2) - dotrc(pa2,wm)*dotrc(pwm,a2)*dotcc(a1,wp)*dotrr(pa1,pwp) 
     &   - dotrc(pa2,wp)*dotrc(pwp,a2)*dotcc(a1,wm)*dotrr(pa1,pwm) + dotcc(a1,wm)*dotcc(a2,wp)*dotrr(pa1,pwm)*dotrr(pa2,pwp)
     &   - dotrc(pa1,wp)*dotrc(pwp,a1)*dotcc(a2,wm)*dotrr(pa2,pwm) + dotcc(a1,wp)*dotcc(a2,wm)*dotrr(pa1,pwp)*dotrr(pa2,pwm) )
      endif

      if (ft2 .ne. 0) then
        wwaa = wwaa + ft2 * gw**4 * sin2w *
     &   ( dotrc(pa1,a2) * dotrc(pa2,wm) * dotrc(pwm,wp) * dotrc(pwp,a1)
     &   - dotrc(pwm,wp) * dotcc(a2,wm) * dotrr(pa1,pa2) * dotrc(pwp,a1)
     &   + dotrc(pwm,a2) * dotcc(wm,wp) * dotrr(pa1,pa2) * dotrc(pwp,a1)
     &   - dotrc(pa1,a2) * dotcc(wm,wp) * dotrr(pa2,pwm) * dotrc(pwp,a1)
     &   + dotrc(pa1,wm) * dotrc(pa2,a1) * dotrc(pwm,wp) * dotrc(pwp,a2)
     &   + dotrc(pa1,a2) * dotrc(pa2,wp) * dotrc(pwm,a1) * dotrc(pwp,wm)
     &   + dotrc(pa1,wp) * dotrc(pa2,a1) * dotrc(pwm,a2) * dotrc(pwp,wm)
     &   - dotrc(pwm,wp) * dotrc(pwp,a2) * dotcc(a1,wm) * dotrr(pa1,pa2)
     &   - dotrc(pwm,a2) * dotrc(pwp,wm) * dotcc(a1,wp) * dotrr(pa1,pa2)
     &   - dotrc(pwm,a1) * dotrc(pwp,wm) * dotcc(a2,wp) * dotrr(pa1,pa2)
     &   + dotrc(pwm,a1) * dotrc(pwp,a2) * dotcc(wm,wp) * dotrr(pa1,pa2)
     &   - dotrc(pa2,wp) * dotrc(pwp,wm) * dotcc(a1,a2) * dotrr(pa1,pwm)
     &   + dotrc(pa2,a1) * dotrc(pwp,wm) * dotcc(a2,wp) * dotrr(pa1,pwm)
     &   - dotrc(pa2,a1) * dotrc(pwp,a2) * dotcc(wm,wp) * dotrr(pa1,pwm)
     &   - dotrc(pa2,wm) * dotrc(pwm,wp) * dotcc(a1,a2) * dotrr(pa1,pwp)
     &   + dotrc(pa2,a1) * dotrc(pwm,wp) * dotcc(a2,wm) * dotrr(pa1,pwp)
     &   - dotrc(pa2,a1) * dotrc(pwm,a2) * dotcc(wm,wp) * dotrr(pa1,pwp)
     &   - dotrc(pa1,wp) * dotrc(pwp,wm) * dotcc(a1,a2) * dotrr(pa2,pwm)
     &   + dotrc(pa1,a2) * dotrc(pwp,wm) * dotcc(a1,wp) * dotrr(pa2,pwm)
     &   + dotcc(a1,a2) * dotcc(wm,wp) * dotrr(pa1,pwp) * dotrr(pa2,pwm)
     &   - dotrc(pa1,wm) * dotrc(pwm,wp) * dotcc(a1,a2) * dotrr(pa2,pwp)
     &   + dotrc(pa1,a2) * dotrc(pwm,wp) * dotcc(a1,wm) * dotrr(pa2,pwp)
     &   - dotrc(pa1,a2) * dotrc(pwm,a1) * dotcc(wm,wp) * dotrr(pa2,pwp)
     &   + dotcc(a1,a2) * dotcc(wm,wp) * dotrr(pa1,pwm) * dotrr(pa2,pwp)
     &   + dotrc(pa1,wp) * dotrc(pa2,wm) * dotcc(a1,a2) * dotrr(pwm,pwp)
     &   + dotrc(pa1,wm) * dotrc(pa2,wp) * dotcc(a1,a2) * dotrr(pwm,pwp)
     &   - dotrc(pa1,a2) * dotrc(pa2,wp) * dotcc(a1,wm) * dotrr(pwm,pwp)
     &   - dotrc(pa1,a2) * dotrc(pa2,wm) * dotcc(a1,wp) * dotrr(pwm,pwp)
     &   - dotrc(pa1,wp) * dotrc(pa2,a1) * dotcc(a2,wm) * dotrr(pwm,pwp)
     &   - dotrc(pa1,wm) * dotrc(pa2,a1) * dotcc(a2,wp) * dotrr(pwm,pwp)
     &   + dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pa1,pa2) * dotrr(pwm,pwp)
     &   + dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa1,pa2) * dotrr(pwm,pwp))
      endif

      if (ft5 .ne. 0) then
        wwaa = wwaa + ft5 * 2. * ee**2 * gw**2 * ( dotrc(pwp,wm)*dotrc(pwm,wp) - dotcc(wp,wm)*dotrr(pwp,pwm) ) * 
     &   ( dotrc(pa1,a2)*dotrc(pa2,a1) - dotcc(a1,a2)*dotrr(pa1,pa2) )
      endif

      if (ft6 .ne. 0) then
        wwaa = wwaa + ft6 * gw**2 * g1**2 * cos2w * 
     &   ( dotrc(pa1,wm)*dotrc(pa2,wp)*dotrc(pwp,a2)*dotrc(pwm,a1) - dotrc(pa1,wm)*dotcc(a2,wp)*dotrr(pa2,pwp)*dotrc(pwm,a1) 
     &   + dotrc(pa1,wp)*dotrc(pa2,wm)*dotrc(pwp,a1)*dotrc(pwm,a2) - dotrc(pa2,wm)*dotrc(pwm,a2)*dotcc(a1,wp)*dotrr(pa1,pwp) 
     &   - dotrc(pa2,wp)*dotrc(pwp,a2)*dotcc(a1,wm)*dotrr(pa1,pwm) + dotcc(a1,wm)*dotcc(a2,wp)*dotrr(pa1,pwm)*dotrr(pa2,pwp)
     &   - dotrc(pa1,wp)*dotrc(pwp,a1)*dotcc(a2,wm)*dotrr(pa2,pwm) + dotcc(a1,wp)*dotcc(a2,wm)*dotrr(pa1,pwp)*dotrr(pa2,pwm) )
      endif

      if (ft7 .ne. 0) then
        wwaa = wwaa + cos2w * ft7 * g1**2 * gw**2 / 4. *
     &   ( dotrc(pa1,a2) * dotrc(pa2,wp) * dotrc(pwp,wm) * dotrc(pwm,a1)
     &   - dotrc(pwp,wm) * dotcc(a2,wp) * dotrr(pa1,pa2) * dotrc(pwm,a1)
     &   + dotrc(pwp,a2) * dotcc(wp,wm) * dotrr(pa1,pa2) * dotrc(pwm,a1)
     &   - dotrc(pa1,a2) * dotcc(wp,wm) * dotrr(pa2,pwp) * dotrc(pwm,a1)
     &   + dotrc(pa1,wp) * dotrc(pa2,a1) * dotrc(pwp,wm) * dotrc(pwm,a2)
     &   + dotrc(pa1,a2) * dotrc(pa2,wm) * dotrc(pwp,a1) * dotrc(pwm,wp)
     &   + dotrc(pa1,wm) * dotrc(pa2,a1) * dotrc(pwp,a2) * dotrc(pwm,wp)
     &   - dotrc(pwp,wm) * dotrc(pwm,a2) * dotcc(a1,wp) * dotrr(pa1,pa2)
     &   - dotrc(pwp,a2) * dotrc(pwm,wp) * dotcc(a1,wm) * dotrr(pa1,pa2)
     &   - dotrc(pwp,a1) * dotrc(pwm,wp) * dotcc(a2,wm) * dotrr(pa1,pa2)
     &   + dotrc(pwp,a1) * dotrc(pwm,a2) * dotcc(wp,wm) * dotrr(pa1,pa2)
     &   - dotrc(pa2,wm) * dotrc(pwm,wp) * dotcc(a1,a2) * dotrr(pa1,pwp)
     &   + dotrc(pa2,a1) * dotrc(pwm,wp) * dotcc(a2,wm) * dotrr(pa1,pwp)
     &   - dotrc(pa2,a1) * dotrc(pwm,a2) * dotcc(wp,wm) * dotrr(pa1,pwp)
     &   - dotrc(pa2,wp) * dotrc(pwp,wm) * dotcc(a1,a2) * dotrr(pa1,pwm)
     &   + dotrc(pa2,a1) * dotrc(pwp,wm) * dotcc(a2,wp) * dotrr(pa1,pwm)
     &   - dotrc(pa2,a1) * dotrc(pwp,a2) * dotcc(wp,wm) * dotrr(pa1,pwm)
     &   - dotrc(pa1,wm) * dotrc(pwm,wp) * dotcc(a1,a2) * dotrr(pa2,pwp)
     &   + dotrc(pa1,a2) * dotrc(pwm,wp) * dotcc(a1,wm) * dotrr(pa2,pwp)
     &   + dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pa1,pwm) * dotrr(pa2,pwp)
     &   - dotrc(pa1,wp) * dotrc(pwp,wm) * dotcc(a1,a2) * dotrr(pa2,pwm)
     &   + dotrc(pa1,a2) * dotrc(pwp,wm) * dotcc(a1,wp) * dotrr(pa2,pwm)
     &   - dotrc(pa1,a2) * dotrc(pwp,a1) * dotcc(wp,wm) * dotrr(pa2,pwm)
     &   + dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pa1,pwp) * dotrr(pa2,pwm)
     &   + dotrc(pa1,wm) * dotrc(pa2,wp) * dotcc(a1,a2) * dotrr(pwp,pwm)
     &   + dotrc(pa1,wp) * dotrc(pa2,wm) * dotcc(a1,a2) * dotrr(pwp,pwm)
     &   - dotrc(pa1,a2) * dotrc(pa2,wm) * dotcc(a1,wp) * dotrr(pwp,pwm)
     &   - dotrc(pa1,a2) * dotrc(pa2,wp) * dotcc(a1,wm) * dotrr(pwp,pwm)
     &   - dotrc(pa1,wm) * dotrc(pa2,a1) * dotcc(a2,wp) * dotrr(pwp,pwm)
     &   - dotrc(pa1,wp) * dotrc(pa2,a1) * dotcc(a2,wm) * dotrr(pwp,pwm)
     &   + dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa1,pa2) * dotrr(pwp,pwm)
     &   + dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pa1,pa2) * dotrr(pwp,pwm) )
      endif

      if (fm0 .ne. 0) then
        wwaa = wwaa - fm0 * 2. * wmass**2 * (
     &        cos2w * g1**2 * dotrc(pwp,wm) * dotrc(pwm,wp) * dotcc(a1,a2)
     &      - cos2w * g1**2 * dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pwp,pwm)
     &      - 2. * cosw * sinw * g1 * gw * dotrc(pwp,wm) * dotrc(pwm,wp) * dotcc(a1,a2)
     &      + 2. * cosw * sinw * g1 * gw * dotcc(a1,a2) * dotcc(wm,wp) * dotrr(pwp,pwm)
     &      + sin2w * gw**2 * dotrc(pwp,wm) * dotrc(pwm,wp) * dotcc(a1,a2)
     &      + sin2w * gw**2 * dotrc(pa1,a2) * dotrc(pa2,a1) * dotcc(wp,wm)
     &      - sin2w * gw**2 * dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pa1,pa2)
     &      - sin2w * gw**2 * dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pwp,pwm) )
      endif

      if (fm1 .ne. 0) then
        wwaa = wwaa - fm1 * wmass**2 / 2. *
     &      ( -cos2w * dotrc(pwp,wm) * dotrc(pwm,a2) * dotcc(a1,wp) * g1**2
     &      - cos2w * dotrc(pwp,a2) * dotrc(pwm,wp) * dotcc(a1,wm) * g1**2
     &      - cos2w * dotrc(pwp,wm) * dotrc(pwm,a1) * dotcc(a2,wp) * g1**2
     &      - cos2w * dotrc(pwp,a1) * dotrc(pwm,wp) * dotcc(a2,wm) * g1**2
     &      + cos2w * dotrc(pwp,a2) * dotrc(pwm,a1) * dotcc(wp,wm) * g1**2
     &      + cos2w * dotrc(pwp,a1) * dotrc(pwm,a2) * dotcc(wp,wm) * g1**2
     &      + cos2w * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pwp,pwm) * g1**2
     &      + cos2w * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pwp,pwm) * g1**2
     &      + 2. * cosw * gw * sinw * dotrc(pwp,wm) * dotrc(pwm,a2) * dotcc(a1,wp) * g1
     &      + 2. * cosw * gw * sinw * dotrc(pwp,a2) * dotrc(pwm,wp) * dotcc(a1,wm) * g1
     &      + 2. * cosw * gw * sinw * dotrc(pwp,wm) * dotrc(pwm,a1) * dotcc(a2,wp) * g1
     &      + 2. * cosw * gw * sinw * dotrc(pwp,a1) * dotrc(pwm,wp) * dotcc(a2,wm) * g1
     &      - 2. * cosw * gw * sinw * dotrc(pwp,a2) * dotrc(pwm,a1) * dotcc(wp,wm) * g1
     &      - 2. * cosw * gw * sinw * dotrc(pwp,a1) * dotrc(pwm,a2) * dotcc(wp,wm) * g1
     &      - 2. * cosw * gw * sinw * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pwp,pwm) * g1
     &      - 2. * cosw * gw * sinw * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pwp,pwm) * g1
     &      + gw**2 * sin2w * dotrc(pa1,wm) * dotrc(pa2,wp) * dotcc(a1,a2)
     &      + gw**2 * sin2w * dotrc(pa1,wp) * dotrc(pa2,wm) * dotcc(a1,a2)
     &      - gw**2 * sin2w * dotrc(pa1,a2) * dotrc(pa2,wm) * dotcc(a1,wp)
     &      - gw**2 * sin2w * dotrc(pwp,wm) * dotrc(pwm,a2) * dotcc(a1,wp)
     &      - gw**2 * sin2w * dotrc(pa1,a2) * dotrc(pa2,wp) * dotcc(a1,wm)
     &      - gw**2 * sin2w * dotrc(pwp,a2) * dotrc(pwm,wp) * dotcc(a1,wm)
     &      - gw**2 * sin2w * dotrc(pa1,wm) * dotrc(pa2,a1) * dotcc(a2,wp)
     &      - gw**2 * sin2w * dotrc(pwp,wm) * dotrc(pwm,a1) * dotcc(a2,wp)
     &      - gw**2 * sin2w * dotrc(pa1,wp) * dotrc(pa2,a1) * dotcc(a2,wm)
     &      - gw**2 * sin2w * dotrc(pwp,a1) * dotrc(pwm,wp) * dotcc(a2,wm)
     &      + gw**2 * sin2w * dotrc(pwp,a2) * dotrc(pwm,a1) * dotcc(wp,wm)
     &      + gw**2 * sin2w * dotrc(pwp,a1) * dotrc(pwm,a2) * dotcc(wp,wm)
     &      + gw**2 * sin2w * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa1,pa2)
     &      + gw**2 * sin2w * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pa1,pa2)
     &      + gw**2 * sin2w * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pwp,pwm)
     &      + gw**2 * sin2w * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pwp,pwm) )
      endif

      if (fm2 .ne. 0) then
        wwaa = wwaa - fm2 * cos2w * g1**2 * wmass**2 * dotcc(wp,wm) * 
     &   ( dotrc(pa1,a2) * dotrc(pa2,a1) - dotcc(a1,a2) * dotrr(pa1,pa2) )
      endif

      if (fm3 .ne. 0) then
        wwaa = wwaa - fm3 * cos2w * g1**2 * wmass**2 / 4.d0 * 
     &   ( (dotrc(pa1,wm) * dotrc(pa2,wp) + dotrc(pa1,wp) * dotrc(pa2,wm)) * dotcc(a1,a2)
     &   - dotrc(pa1,a2) * dotrc(pa2,wm) * dotcc(a1,wp) - dotrc(pa1,a2) * dotrc(pa2,wp) * dotcc(a1,wm)
     &   - dotrc(pa1,wm) * dotrc(pa2,a1) * dotcc(a2,wp) - dotrc(pa1,wp) * dotrc(pa2,a1) * dotcc(a2,wm)
     &   + (dotcc(a1,wm) * dotcc(a2,wp) + dotcc(a1,wp) * dotcc(a2,wm)) * dotrr(pa1,pa2) )
      endif

      if (fm4 .ne. 0) then
        wwaa = wwaa - fm4 * cosw * g1 * wmass**2 / 2. *
     &   ( cosw * g1 * dotrc(pa2,wm) * dotrc(pwm,a2) * dotcc(a1,wp)
     &   - sinw * gw * dotrc(pa2,wm) * dotrc(pwm,a2) * dotcc(a1,wp)
     &   - cosw * g1 * dotcc(a2,wm) * dotrr(pa1,pwp) * dotcc(a1,wp)
     &   + sinw * gw * dotcc(a2,wm) * dotrr(pa1,pwp) * dotcc(a1,wp)
     &   - cosw * g1 * dotcc(a2,wm) * dotrr(pa2,pwm) * dotcc(a1,wp)
     &   + sinw * gw * dotcc(a2,wm) * dotrr(pa2,pwm) * dotcc(a1,wp)
     &   + cosw * g1 * dotrc(pa2,wp) * dotrc(pwp,a2) * dotcc(a1,wm)
     &   - sinw * gw * dotrc(pa2,wp) * dotrc(pwp,a2) * dotcc(a1,wm)
     &   + cosw * g1 * dotrc(pa1,wm) * dotrc(pwm,a1) * dotcc(a2,wp)
     &   - sinw * gw * dotrc(pa1,wm) * dotrc(pwm,a1) * dotcc(a2,wp)
     &   + cosw * g1 * dotrc(pa1,wp) * dotrc(pwp,a1) * dotcc(a2,wm)
     &   - sinw * gw * dotrc(pa1,wp) * dotrc(pwp,a1) * dotcc(a2,wm)
     &   + 2. * sinw * gw * dotrc(pa1,a2) * dotrc(pa2,a1) * dotcc(wp,wm)
     &   - 2. * sinw * gw * dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pa1,pa2)
     &   - cosw * g1 * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa1,pwm)
     &   + sinw * gw * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa1,pwm)
     &   - cosw * g1 * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa2,pwp)
     &   + sinw * gw * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa2,pwp) )
      endif

      if (fm5 .ne. 0) then
        wwaa = wwaa - cosw * fm5 * g1 * wmass**2 / 4. *
     &   ( -gw * sinw * dotrc(pa1,wp) * dotrc(pa2,wm) * dotcc(a1,a2)
     &   - gw * sinw * dotrc(pa1,wm) * dotrc(pa2,wp) * dotcc(a1,a2)
     &   + cosw * g1 * dotrc(pa1,wm) * dotrc(pwm,wp) * dotcc(a1,a2)
     &   - gw * sinw * dotrc(pa1,wm) * dotrc(pwm,wp) * dotcc(a1,a2)
     &   + cosw * g1 * dotrc(pa2,wm) * dotrc(pwm,wp) * dotcc(a1,a2)
     &   - gw * sinw * dotrc(pa2,wm) * dotrc(pwm,wp) * dotcc(a1,a2)
     &   - cosw * g1 * dotcc(wm,wp) * dotrr(pa1,pwm) * dotcc(a1,a2)
     &   + gw * sinw * dotcc(wm,wp) * dotrr(pa1,pwm) * dotcc(a1,a2)
     &   - cosw * g1 * dotcc(wm,wp) * dotrr(pa2,pwm) * dotcc(a1,a2)
     &   + gw * sinw * dotcc(wm,wp) * dotrr(pa2,pwm) * dotcc(a1,a2)
     &   + gw * sinw * dotrc(pa1,a2) * dotrc(pa2,wp) * dotcc(a1,wm)
     &   - cosw * g1 * dotrc(pa1,a2) * dotrc(pwm,wp) * dotcc(a1,wm)
     &   + gw * sinw * dotrc(pa1,a2) * dotrc(pwm,wp) * dotcc(a1,wm)
     &   + cosw * g1 * dotrc(pa1,wp) * dotrc(pwp,a2) * dotcc(a1,wm)
     &   - gw * sinw * dotrc(pa1,wp) * dotrc(pwp,a2) * dotcc(a1,wm)
     &   + gw * sinw * dotrc(pa1,a2) * dotrc(pa2,wm) * dotcc(a1,wp)
     &   - cosw * g1 * dotrc(pa1,wm) * dotrc(pwp,a2) * dotcc(a1,wp)
     &   + gw * sinw * dotrc(pa1,wm) * dotrc(pwp,a2) * dotcc(a1,wp)
     &   + cosw * g1 * dotrc(pa2,wm) * dotrc(pwp,a2) * dotcc(a1,wp)
     &   - gw * sinw * dotrc(pa2,wm) * dotrc(pwp,a2) * dotcc(a1,wp)
     &   + gw * sinw * dotrc(pa1,wp) * dotrc(pa2,a1) * dotcc(a2,wm)
     &   - cosw * g1 * dotrc(pa2,a1) * dotrc(pwm,wp) * dotcc(a2,wm)
     &   + gw * sinw * dotrc(pa2,a1) * dotrc(pwm,wp) * dotcc(a2,wm)
     &   + cosw * g1 * dotrc(pa2,wp) * dotrc(pwp,a1) * dotcc(a2,wm)
     &   - gw * sinw * dotrc(pa2,wp) * dotrc(pwp,a1) * dotcc(a2,wm)
     &   + gw * sinw * dotrc(pa1,wm) * dotrc(pa2,a1) * dotcc(a2,wp)
     &   + cosw * g1 * dotrc(pa1,wm) * dotrc(pwp,a1) * dotcc(a2,wp)
     &   - gw * sinw * dotrc(pa1,wm) * dotrc(pwp,a1) * dotcc(a2,wp)
     &   - cosw * g1 * dotrc(pa2,wm) * dotrc(pwp,a1) * dotcc(a2,wp)
     &   + gw * sinw * dotrc(pa2,wm) * dotrc(pwp,a1) * dotcc(a2,wp)
     &   + cosw * g1 * dotrc(pa1,a2) * dotrc(pwm,a1) * dotcc(wm,wp)
     &   - gw * sinw * dotrc(pa1,a2) * dotrc(pwm,a1) * dotcc(wm,wp)
     &   + cosw * g1 * dotrc(pa2,a1) * dotrc(pwm,a2) * dotcc(wm,wp)
     &   - gw * sinw * dotrc(pa2,a1) * dotrc(pwm,a2) * dotcc(wm,wp)
     &   - gw * sinw * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pa1,pa2)
     &   - gw * sinw * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa1,pa2)
     &   - cosw * g1 * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa1,pwp)
     &   + gw * sinw * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa1,pwp)
     &   - cosw * g1 * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pa2,pwp)
     &   + gw * sinw * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pa2,pwp) )
      endif

      if (fm6 .ne. 0) then
        wwaa = wwaa - fm6 * wmass**2 * dotcc(wp,wm) * gw**2 * sin2w *
     &      ( dotrc(pa1,a2) * dotrc(pa2,a1) - dotcc(a1,a2) * dotrr(pa1,pa2) )
      endif

      if (fm7 .ne. 0) then
        wwaa = wwaa + fm7 * wmass**2 / 4. *
     &   ( -cos2w * dotrc(pwp,wm) * dotrc(pwm,a2) * dotcc(a1,wp) * g1**2
     &   - cos2w * dotrc(pwp,a2) * dotrc(pwm,wp) * dotcc(a1,wm) * g1**2
     &   - cos2w * dotrc(pwp,wm) * dotrc(pwm,a1) * dotcc(a2,wp) * g1**2
     &   - cos2w * dotrc(pwp,a1) * dotrc(pwm,wp) * dotcc(a2,wm) * g1**2
     &   + cos2w * dotrc(pwp,a2) * dotrc(pwm,a1) * dotcc(wp,wm) * g1**2
     &   + cos2w * dotrc(pwp,a1) * dotrc(pwm,a2) * dotcc(wp,wm) * g1**2
     &   + cos2w * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pwp,pwm) * g1**2
     &   + cos2w * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pwp,pwm) * g1**2
     &   - cosw * gw * sinw * dotrc(pa2,wp) * dotrc(pwp,wm) * dotcc(a1,a2) * g1
     &   - cosw * gw * sinw * dotrc(pa2,wm) * dotrc(pwm,wp) * dotcc(a1,a2) * g1
     &   + cosw * gw * sinw * dotrc(pa2,wm) * dotrc(pwp,a2) * dotcc(a1,wp) * g1
     &   + cosw * gw * sinw * dotrc(pa1,a2) * dotrc(pwp,wm) * dotcc(a1,wp) * g1
     &   + 2. * cosw * gw * sinw * dotrc(pwp,wm) * dotrc(pwm,a2) * dotcc(a1,wp) * g1
     &   + cosw * gw * sinw * dotrc(pa2,wp) * dotrc(pwm,a2) * dotcc(a1,wm) * g1
     &   + cosw * gw * sinw * dotrc(pa1,a2) * dotrc(pwm,wp) * dotcc(a1,wm) * g1
     &   + 2. * cosw * gw * sinw * dotrc(pwp,a2) * dotrc(pwm,wp) * dotcc(a1,wm) * g1
     &   - cosw * gw * sinw * dotrc(pa2,wm) * dotrc(pwp,a1) * dotcc(a2,wp) * g1
     &   + cosw * gw * sinw * dotrc(pa2,a1) * dotrc(pwp,wm) * dotcc(a2,wp) * g1
     &   + cosw * gw * sinw * dotrc(pa2,wm) * dotrc(pwm,a1) * dotcc(a2,wp) * g1
     &   + 2. * cosw * gw * sinw * dotrc(pwp,wm) * dotrc(pwm,a1) * dotcc(a2,wp) * g1
     &   + cosw * gw * sinw * dotrc(pa2,wp) * dotrc(pwp,a1) * dotcc(a2,wm) * g1
     &   - cosw * gw * sinw * dotrc(pa2,wp) * dotrc(pwm,a1) * dotcc(a2,wm) * g1
     &   + cosw * gw * sinw * dotrc(pa2,a1) * dotrc(pwm,wp) * dotcc(a2,wm) * g1
     &   + 2. * cosw * gw * sinw * dotrc(pwp,a1) * dotrc(pwm,wp) * dotcc(a2,wm) * g1
     &   - cosw * gw * sinw * dotrc(pa1,a2) * dotrc(pwp,a1) * dotcc(wp,wm) * g1
     &   - cosw * gw * sinw * dotrc(pa2,a1) * dotrc(pwp,a2) * dotcc(wp,wm) * g1
     &   - cosw * gw * sinw * dotrc(pa1,a2) * dotrc(pwm,a1) * dotcc(wp,wm) * g1
     &   - 2. * cosw * gw * sinw * dotrc(pwp,a2) * dotrc(pwm,a1) * dotcc(wp,wm) * g1
     &   - cosw * gw * sinw * dotrc(pa2,a1) * dotrc(pwm,a2) * dotcc(wp,wm) * g1
     &   - 2. * cosw * gw * sinw * dotrc(pwp,a1) * dotrc(pwm,a2) * dotcc(wp,wm) * g1
     &   - cosw * gw * sinw * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa1,pwp) * g1
     &   + cosw * gw * sinw * dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pa1,pwp) * g1
     &   - cosw * gw * sinw * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pa1,pwm) * g1
     &   + cosw * gw * sinw * dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pa1,pwm) * g1
     &   - cosw * gw * sinw * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pa2,pwp) * g1
     &   + cosw * gw * sinw * dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pa2,pwp) * g1
     &   - cosw * gw * sinw * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa2,pwm) * g1
     &   + cosw * gw * sinw * dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pa2,pwm) * g1
     &   - 2. * cosw * gw * sinw * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pwp,pwm) * g1
     &   - 2. * cosw * gw * sinw * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pwp,pwm) * g1
     &   + gw**2 * sin2w * dotrc(pa2,wp) * dotrc(pwp,wm) * dotcc(a1,a2)
     &   + gw**2 * sin2w * dotrc(pa2,wm) * dotrc(pwm,wp) * dotcc(a1,a2)
     &   - gw**2 * sin2w * dotrc(pa1,a2) * dotrc(pa2,wm) * dotcc(a1,wp)
     &   - gw**2 * sin2w * dotrc(pa2,wm) * dotrc(pwp,a2) * dotcc(a1,wp)
     &   - gw**2 * sin2w * dotrc(pa1,a2) * dotrc(pwp,wm) * dotcc(a1,wp)
     &   - gw**2 * sin2w * dotrc(pwp,wm) * dotrc(pwm,a2) * dotcc(a1,wp)
     &   - gw**2 * sin2w * dotrc(pa1,a2) * dotrc(pa2,wp) * dotcc(a1,wm)
     &   - gw**2 * sin2w * dotrc(pa2,wp) * dotrc(pwm,a2) * dotcc(a1,wm)
     &   - gw**2 * sin2w * dotrc(pa1,a2) * dotrc(pwm,wp) * dotcc(a1,wm)
     &   - gw**2 * sin2w * dotrc(pwp,a2) * dotrc(pwm,wp) * dotcc(a1,wm)
     &   + gw**2 * sin2w * dotrc(pa2,wm) * dotrc(pwp,a1) * dotcc(a2,wp)
     &   - gw**2 * sin2w * dotrc(pa2,a1) * dotrc(pwp,wm) * dotcc(a2,wp)
     &   - gw**2 * sin2w * dotrc(pa2,wm) * dotrc(pwm,a1) * dotcc(a2,wp)
     &   - gw**2 * sin2w * dotrc(pwp,wm) * dotrc(pwm,a1) * dotcc(a2,wp)
     &   + gw * sinw * dotrc(pa1,wm) * (gw * sinw * dotrc(pa2,wp) * dotcc(a1,a2)
     &         + (gw * sinw - cosw * g1) * dotrc(pwm,wp) * dotcc(a1,a2)
     &         - cosw * g1 * dotrc(pwp,a2) * dotcc(a1,wp)
     &         + gw * sinw * dotrc(pwp,a2) * dotcc(a1,wp)
     &         + cosw * g1 * dotrc(pwm,a2) * dotcc(a1,wp)
     &         - gw * sinw * dotrc(pwm,a2) * dotcc(a1,wp)
     &         - gw * sinw * dotrc(pa2,a1) * dotcc(a2,wp)
     &         + cosw * g1 * dotrc(pwp,a1) * dotcc(a2,wp)
     &         - gw * sinw * dotrc(pwp,a1) * dotcc(a2,wp) )
     &   - gw**2 * sin2w * dotrc(pa2,wp) * dotrc(pwp,a1) * dotcc(a2,wm)
     &   + gw**2 * sin2w * dotrc(pa2,wp) * dotrc(pwm,a1) * dotcc(a2,wm)
     &   - gw**2 * sin2w * dotrc(pa2,a1) * dotrc(pwm,wp) * dotcc(a2,wm)
     &   - gw**2 * sin2w * dotrc(pwp,a1) * dotrc(pwm,wp) * dotcc(a2,wm)
     &   + gw * sinw * dotrc(pa1,wp) * (gw * sinw * dotrc(pa2,wm) * dotcc(a1,a2)
     &         + (gw * sinw - cosw * g1) * dotrc(pwp,wm) * dotcc(a1,a2)
     &         + cosw * g1 * dotrc(pwp,a2) * dotcc(a1,wm)
     &         - gw * sinw * dotrc(pwp,a2) * dotcc(a1,wm)
     &         - cosw * g1 * dotrc(pwm,a2) * dotcc(a1,wm)
     &         + gw * sinw * dotrc(pwm,a2) * dotcc(a1,wm)
     &         - gw * sinw * dotrc(pa2,a1) * dotcc(a2,wm)
     &         + cosw * g1 * dotrc(pwm,a1) * dotcc(a2,wm)
     &         - gw * sinw * dotrc(pwm,a1) * dotcc(a2,wm) )
     &   + gw**2 * sin2w * dotrc(pa1,a2) * dotrc(pwp,a1) * dotcc(wp,wm)
     &   + gw**2 * sin2w * dotrc(pa2,a1) * dotrc(pwp,a2) * dotcc(wp,wm)
     &   + gw**2 * sin2w * dotrc(pa1,a2) * dotrc(pwm,a1) * dotcc(wp,wm)
     &   + gw**2 * sin2w * dotrc(pwp,a2) * dotrc(pwm,a1) * dotcc(wp,wm)
     &   + gw**2 * sin2w * dotrc(pa2,a1) * dotrc(pwm,a2) * dotcc(wp,wm)
     &   + gw**2 * sin2w * dotrc(pwp,a1) * dotrc(pwm,a2) * dotcc(wp,wm)
     &   + gw**2 * sin2w * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa1,pa2)
     &   + gw**2 * sin2w * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pa1,pa2)
     &   + gw**2 * sin2w * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa1,pwp)
     &   - gw**2 * sin2w * dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pa1,pwp)
     &   + gw**2 * sin2w * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pa1,pwm)
     &   - gw**2 * sin2w * dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pa1,pwm)
     &   + gw**2 * sin2w * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pa2,pwp)
     &   - gw**2 * sin2w * dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pa2,pwp)
     &   + gw**2 * sin2w * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pa2,pwm)
     &   - gw**2 * sin2w * dotcc(a1,a2) * dotcc(wp,wm) * dotrr(pa2,pwm)
     &   + gw**2 * sin2w * dotcc(a1,wm) * dotcc(a2,wp) * dotrr(pwp,pwm)
     &   + gw**2 * sin2w * dotcc(a1,wp) * dotcc(a2,wm) * dotrr(pwp,pwm) )
      endif

      if (fwww .ne. 0) then
        wwaa = wwaa - fwww * 3./2. * gw**4 * sin2w *
     &      ( (dotrc(pa2,a1) * (dotrc(pwm,a2) + dotrc(pwp,a2)) + dotrc(pa1,a2) * (dotrc(pwm,a1) + dotrc(pwp,a1)) ) * dotcc(wp,wm)
     &      - dotcc(a1,a2) * dotcc(wp,wm) * (dotrr(pwm,pa1) + dotrr(pwm,pa2) + dotrr(pwp,pa1) + dotrr(pwp,pa2))
     &      - dotcc(a2,wm) * ( dotrc(pa2,a1)*dotrc(pwm,wp) + dotrc(pwm,a1)*(dotrc(pa1,wp)-dotrc(pa2,wp)) 
     &                       + dotrc(pwp,a1)*dotrc(pa2,wp) )
     &      - dotcc(a1,wm) * ( dotrc(pa1,a2)*dotrc(pwm,wp) + dotrc(pwp,a2)*dotrc(pa1,wp)
     &                       + dotrc(pwm,a2) * (dotrc(pa2,wp)-dotrc(pa1,wp)) )
     &      - dotcc(a2,wp) * ( dotrc(pa2,a1)*dotrc(pwp,wm) + dotrc(pwp,a1) * (dotrc(pa1,wm)-dotrc(pa2,wm))
     &                       + dotrc(pwm,a1)*dotrc(pa2,wm) )
     &      - dotcc(a1,wp) * ( dotrc(pa1,a2)*dotrc(pwp,wm) + dotrc(pwm,a2)*dotrc(pa1,wm)
     &                       + dotrc(pwp,a2) * (dotrc(pa2,wm) - dotrc(pa1,wm)) )
     &      + dotcc(a1,a2) * ( (dotrc(pa1,wp)+dotrc(pa2,wp))*dotrc(pwp,wm) + dotrc(pwm,wp)*(dotrc(pa1,wm)+dotrc(pa2,wm)) )
     &      + dotcc(a1,wm) * dotcc(a2,wp) * ( dotrr(pwm,pa2) + dotrr(pwp,pa1) )
     &      + dotcc(a1,wp) * dotcc(a2,wm) * ( dotrr(pwm,pa1) + dotrr(pwp,pa2) ) )
      endif

      return
      end



      subroutine wwza_anomal8(wm,z,wp,a, wwza)
c
c This subroutine computes the wwza-vertex with anomalous couplings
c     
      implicit none
      double complex wp(6),wm(6),z(6),a(6),wwza, dotcc, dotrc
      double precision pwp(0:3),pwm(0:3),pz(0:3),pa(0:3), dotrr
      double precision cos2w, g1, cosw, sinw
      integer i
      external dotcc, dotrc, dotrr

#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/an_couplings.inc"   

      cos2w = 1.0d0 - sin2w
      cosw = sqrt(cos2w)
      sinw = sqrt(sin2w)
      g1 = ee / cosw

      pwm(0) = dble( wm(5))
      pwm(1) = dble( wm(6))
      pwm(2) = dimag(wm(6))
      pwm(3) = dimag(wm(5))
      pwp(0) = dble( wp(5))
      pwp(1) = dble( wp(6))
      pwp(2) = dimag(wp(6))
      pwp(3) = dimag(wp(5))
      pz(0)  = dble( z(5))
      pz(1)  = dble( z(6))
      pz(2)  = dimag(z(6))
      pz(3)  = dimag(z(5))
      pa(0)  = dble( a(5))
      pa(1)  = dble( a(6))
      pa(2)  = dimag(a(6))
      pa(3)  = dimag(a(5))

      wwza = gwwz * gwwa * (dotcc(wm,z)*dotcc(wp,a) + dotcc(wm,a)*dotcc(wp,z) - 2.0d0*dotcc(wm,wp)*dotcc(z,a))

      if (ft0 .ne. 0) then
        wwza = wwza + ft0 * 8. * gw**4 * sqrt(cos2w * sin2w) * 
     &   ( dotrc(pwp,wm)*dotrc(pwm,wp) - dotcc(wp,wm)*dotrr(pwp,pwm) ) * ( dotrc(pz,a)*dotrc(pa,z) - dotcc(z,a)*dotrr(pz,pa) )
      endif

      if (ft1 .ne. 0) then
        wwza = wwza + ft1 * 4. * gw**4 * sqrt(cos2w * sin2w) * 
     &   ( dotrc(pa,wm)*dotrc(pwp,z)*dotrc(pwm,a)*dotrc(pz,wp) - dotrc(pwp,z)*dotcc(wm,a)*dotrr(pwm,pa)*dotrc(pz,wp) 
     &   + dotrc(pa,wp)*dotrc(pwp,a)*dotrc(pwm,z)*dotrc(pz,wm) - dotrc(pwm,z)*dotrc(pz,wm)*dotcc(wp,a)*dotrr(pwp,pa) 
     &   - dotrc(pa,wm)*dotrc(pwm,a)*dotcc(wp,z)*dotrr(pwp,pz) + dotcc(a,wm)*dotcc(z,wp)*dotrr(pa,pwm)*dotrr(pz,pwp)
     &   - dotrc(pa,wp)*dotrc(pwp,a)*dotcc(wm,z)*dotrr(pwm,pz) + dotcc(a,wp)*dotcc(z,wm)*dotrr(pa,pwp)*dotrr(pz,pwm) )
      endif

      if (ft2 .ne. 0) then
        wwza = wwza + cosw * ft2 * gw**4 * sinw *
     &   ( dotrc(pa,wm) * dotrc(pwp,z) * dotrc(pwm,wp) * dotrc(pz,a)
     &   + dotrc(pa,wp) * dotrc(pwp,wm) * dotrc(pwm,z) * dotrc(pz,a)
     &   - dotrc(pwm,z) * dotcc(wp,wm) * dotrr(pa,pwp) * dotrc(pz,a)
     &   + dotrc(pwm,wp) * dotcc(wm,z) * dotrr(pa,pwp) * dotrc(pz,a)
     &   - dotrc(pwp,z) * dotcc(wp,wm) * dotrr(pa,pwm) * dotrc(pz,a)
     &   + dotrc(pwp,wm) * dotcc(wp,z) * dotrr(pa,pwm) * dotrc(pz,a)
     &   - dotrc(pa,wm) * dotcc(wp,z) * dotrr(pwp,pwm) * dotrc(pz,a)
     &   - dotrc(pa,wp) * dotcc(wm,z) * dotrr(pwp,pwm) * dotrc(pz,a)
     &   + dotrc(pa,z) * dotrc(pwp,wm) * dotrc(pwm,a) * dotrc(pz,wp)
     &   + dotrc(pa,z) * dotrc(pwp,a) * dotrc(pwm,wp) * dotrc(pz,wm)
     &   - dotrc(pwm,wp) * dotrc(pz,wm) * dotcc(a,z) * dotrr(pa,pwp)
     &   - dotrc(pwp,wm) * dotrc(pz,wp) * dotcc(a,z) * dotrr(pa,pwm)
     &   - dotrc(pwp,wm) * dotrc(pwm,z) * dotcc(a,wp) * dotrr(pa,pz)
     &   - dotrc(pwp,z) * dotrc(pwm,wp) * dotcc(a,wm) * dotrr(pa,pz)
     &   + dotrc(pwp,z) * dotrc(pwm,a) * dotcc(wp,wm) * dotrr(pa,pz)
     &   + dotrc(pwp,a) * dotrc(pwm,z) * dotcc(wp,wm) * dotrr(pa,pz)
     &   - dotrc(pwp,wm) * dotrc(pwm,a) * dotcc(wp,z) * dotrr(pa,pz)
     &   - dotrc(pwp,a) * dotrc(pwm,wp) * dotcc(wm,z) * dotrr(pa,pz)
     &   - dotrc(pa,z) * dotrc(pz,wm) * dotcc(a,wp) * dotrr(pwp,pwm)
     &   - dotrc(pa,z) * dotrc(pz,wp) * dotcc(a,wm) * dotrr(pwp,pwm)
     &   + dotrc(pa,wm) * dotrc(pz,wp) * dotcc(a,z) * dotrr(pwp,pwm)
     &   + dotrc(pa,wp) * dotrc(pz,wm) * dotcc(a,z) * dotrr(pwp,pwm)
     &   + dotcc(a,wm) * dotcc(wp,z) * dotrr(pa,pz) * dotrr(pwp,pwm)
     &   + dotcc(a,wp) * dotcc(wm,z) * dotrr(pa,pz) * dotrr(pwp,pwm)
     &   + dotrc(pa,z) * dotrc(pwm,wp) * dotcc(a,wm) * dotrr(pwp,pz)
     &   - dotrc(pa,wm) * dotrc(pwm,wp) * dotcc(a,z) * dotrr(pwp,pz)
     &   - dotrc(pa,z) * dotrc(pwm,a) * dotcc(wp,wm) * dotrr(pwp,pz)
     &   + dotcc(a,z) * dotcc(wp,wm) * dotrr(pa,pwm) * dotrr(pwp,pz)
     &   + dotrc(pa,z) * dotrc(pwp,wm) * dotcc(a,wp) * dotrr(pwm,pz)
     &   - dotrc(pa,wp) * dotrc(pwp,wm) * dotcc(a,z) * dotrr(pwm,pz)
     &   - dotrc(pa,z) * dotrc(pwp,a) * dotcc(wp,wm) * dotrr(pwm,pz)
     &   + dotcc(a,z) * dotcc(wp,wm) * dotrr(pa,pwp) * dotrr(pwm,pz) )
      endif

      if (ft5 .ne. 0) then
        wwza = wwza - ft5 * 2. * ee**2 * gw**2 * sqrt(sin2w / cos2w) *
     &   ( dotrc(pwp,wm)*dotrc(pwm,wp) - dotcc(wp,wm)*dotrr(pwp,pwm) ) * ( dotrc(pz,a)*dotrc(pa,z) - dotcc(z,a)*dotrr(pz,pa) )
      endif

      if (ft6 .ne. 0) then
        wwza = wwza - ft6 * g1**2 * gw**2 * sqrt(cos2w * sin2w) * 
     &   ( dotrc(pa,wm)*dotrc(pwp,z)*dotrc(pwm,a)*dotrc(pz,wp) - dotrc(pwp,z)*dotcc(wm,a)*dotrr(pwm,pa)*dotrc(pz,wp) 
     &   + dotrc(pa,wp)*dotrc(pwp,a)*dotrc(pwm,z)*dotrc(pz,wm) - dotrc(pwm,z)*dotrc(pz,wm)*dotcc(wp,a)*dotrr(pwp,pa) 
     &   - dotrc(pa,wm)*dotrc(pwm,a)*dotcc(wp,z)*dotrr(pwp,pz) + dotcc(a,wm)*dotcc(z,wp)*dotrr(pa,pwm)*dotrr(pz,pwp)
     &   - dotrc(pa,wp)*dotrc(pwp,a)*dotcc(wm,z)*dotrr(pwm,pz) + dotcc(a,wp)*dotcc(z,wm)*dotrr(pa,pwp)*dotrr(pz,pwm) )
      endif

      if (ft7 .ne. 0) then
        wwza = wwza - cosw * ft7 * g1**2 * gw**2 * sinw / 4. *
     &   ( dotrc(pa,wm) * dotrc(pwp,z) * dotrc(pwm,wp) * dotrc(pz,a)
     &   + dotrc(pa,wp) * dotrc(pwp,wm) * dotrc(pwm,z) * dotrc(pz,a)
     &   - dotrc(pwm,z) * dotcc(wp,wm) * dotrr(pa,pwp) * dotrc(pz,a)
     &   + dotrc(pwm,wp) * dotcc(wm,z) * dotrr(pa,pwp) * dotrc(pz,a)
     &   - dotrc(pwp,z) * dotcc(wp,wm) * dotrr(pa,pwm) * dotrc(pz,a)
     &   + dotrc(pwp,wm) * dotcc(wp,z) * dotrr(pa,pwm) * dotrc(pz,a)
     &   - dotrc(pa,wm) * dotcc(wp,z) * dotrr(pwp,pwm) * dotrc(pz,a)
     &   - dotrc(pa,wp) * dotcc(wm,z) * dotrr(pwp,pwm) * dotrc(pz,a)
     &   + dotrc(pa,z) * dotrc(pwp,wm) * dotrc(pwm,a) * dotrc(pz,wp)
     &   + dotrc(pa,z) * dotrc(pwp,a) * dotrc(pwm,wp) * dotrc(pz,wm)
     &   - dotrc(pwm,wp) * dotrc(pz,wm) * dotcc(a,z) * dotrr(pa,pwp)
     &   - dotrc(pwp,wm) * dotrc(pz,wp) * dotcc(a,z) * dotrr(pa,pwm)
     &   - dotrc(pwp,wm) * dotrc(pwm,z) * dotcc(a,wp) * dotrr(pa,pz)
     &   - dotrc(pwp,z) * dotrc(pwm,wp) * dotcc(a,wm) * dotrr(pa,pz)
     &   + dotrc(pwp,z) * dotrc(pwm,a) * dotcc(wp,wm) * dotrr(pa,pz)
     &   + dotrc(pwp,a) * dotrc(pwm,z) * dotcc(wp,wm) * dotrr(pa,pz)
     &   - dotrc(pwp,wm) * dotrc(pwm,a) * dotcc(wp,z) * dotrr(pa,pz)
     &   - dotrc(pwp,a) * dotrc(pwm,wp) * dotcc(wm,z) * dotrr(pa,pz)
     &   - dotrc(pa,z) * dotrc(pz,wm) * dotcc(a,wp) * dotrr(pwp,pwm)
     &   - dotrc(pa,z) * dotrc(pz,wp) * dotcc(a,wm) * dotrr(pwp,pwm)
     &   + dotrc(pa,wm) * dotrc(pz,wp) * dotcc(a,z) * dotrr(pwp,pwm)
     &   + dotrc(pa,wp) * dotrc(pz,wm) * dotcc(a,z) * dotrr(pwp,pwm)
     &   + dotcc(a,wm) * dotcc(wp,z) * dotrr(pa,pz) * dotrr(pwp,pwm)
     &   + dotcc(a,wp) * dotcc(wm,z) * dotrr(pa,pz) * dotrr(pwp,pwm)
     &   + dotrc(pa,z) * dotrc(pwm,wp) * dotcc(a,wm) * dotrr(pwp,pz)
     &   - dotrc(pa,wm) * dotrc(pwm,wp) * dotcc(a,z) * dotrr(pwp,pz)
     &   - dotrc(pa,z) * dotrc(pwm,a) * dotcc(wp,wm) * dotrr(pwp,pz)
     &   + dotcc(a,z) * dotcc(wp,wm) * dotrr(pa,pwm) * dotrr(pwp,pz)
     &   + dotrc(pa,z) * dotrc(pwp,wm) * dotcc(a,wp) * dotrr(pwm,pz)
     &   - dotrc(pa,wp) * dotrc(pwp,wm) * dotcc(a,z) * dotrr(pwm,pz)
     &   - dotrc(pa,z) * dotrc(pwp,a) * dotcc(wp,wm) * dotrr(pwm,pz)
     &   + dotcc(a,z) * dotcc(wp,wm) * dotrr(pa,pwp) * dotrr(pwm,pz) )
      endif

      if (fm0 .ne. 0) then
        wwza = wwza + fm0 * 2. * wmass**2 * (
     &        cos2w * g1 * gw * dotrc(pwp,wm) * dotrc(pwm,wp) * dotcc(a,z)
     &      - cos2w * g1 * gw * dotcc(wp,wm) * dotcc(a,z) * dotrr(pwp,pwm)
     &      + sinw * cosw * g1**2 * dotrc(pwp,wm) * dotrc(pwm,wp) * dotcc(a,z) 
     &      - sinw * cosw * gw**2 * dotrc(pwp,wm) * dotrc(pwm,wp) * dotcc(a,z) 
     &      - sinw * cosw * gw**2 * dotrc(pa,z) * dotrc(pz,a) * dotcc(wp,wm) 
     &      + sinw * cosw * gw**2 * dotcc(a,z) * dotcc(wp,wm) * dotrr(pa,pz) 
     &      - sinw * cosw * g1**2 * dotcc(a,z) * dotcc(wp,wm) * dotrr(pwp,pwm) 
     &      + sinw * cosw * gw**2 * dotcc(a,z) * dotcc(wp,wm) * dotrr(pwp,pwm) 
     &      - sin2w * g1 * gw * dotrc(pwp,wm) * dotrc(pwm,wp) * dotcc(a,z)
     &      + sin2w * g1 * gw * dotcc(a,z) * dotcc(wp,wm) * dotrr(pwp,pwm) ) 
      endif

      if (fm1 .ne. 0) then
        wwza = wwza - fm1 * wmass**2 / 2. *
     &      ( g1 * gw * dotrc(pwp,wm) * dotrc(pwm,z) * dotcc(a,wp) * cos2w
     &      + g1 * gw * dotrc(pwp,z) * dotrc(pwm,wp) * dotcc(a,wm) * cos2w
     &      + g1 * gw * dotrc(pwp,wm) * dotrc(pwm,a) * dotcc(z,wp) * cos2w
     &      + g1 * gw * dotrc(pwp,a) * dotrc(pwm,wp) * dotcc(z,wm) * cos2w
     &      - g1 * gw * dotrc(pwp,z) * dotrc(pwm,a) * dotcc(wp,wm) * cos2w
     &      - g1 * gw * dotrc(pwp,a) * dotrc(pwm,z) * dotcc(wp,wm) * cos2w
     &      - g1 * gw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pwp,pwm) * cos2w
     &      - g1 * gw * dotcc(a,wp) * dotcc(z,wm) * dotrr(pwp,pwm) * cos2w
     &      + gw**2 * sinw * dotrc(pa,wm) * dotrc(pz,wp) * dotcc(a,z) * cosw
     &      + gw**2 * sinw * dotrc(pa,wp) * dotrc(pz,wm) * dotcc(a,z) * cosw
     &      - gw**2 * sinw * dotrc(pa,z) * dotrc(pz,wm) * dotcc(a,wp) * cosw
     &      + g1**2 * sinw * dotrc(pwp,wm) * dotrc(pwm,z) * dotcc(a,wp) * cosw
     &      - gw**2 * sinw * dotrc(pwp,wm) * dotrc(pwm,z) * dotcc(a,wp) * cosw
     &      - gw**2 * sinw * dotrc(pa,z) * dotrc(pz,wp) * dotcc(a,wm) * cosw
     &      + g1**2 * sinw * dotrc(pwp,z) * dotrc(pwm,wp) * dotcc(a,wm) * cosw
     &      - gw**2 * sinw * dotrc(pwp,z) * dotrc(pwm,wp) * dotcc(a,wm) * cosw
     &      - gw**2 * sinw * dotrc(pa,wm) * dotrc(pz,a) * dotcc(z,wp) * cosw
     &      + g1**2 * sinw * dotrc(pwp,wm) * dotrc(pwm,a) * dotcc(z,wp) * cosw
     &      - gw**2 * sinw * dotrc(pwp,wm) * dotrc(pwm,a) * dotcc(z,wp) * cosw
     &      - gw**2 * sinw * dotrc(pa,wp) * dotrc(pz,a) * dotcc(z,wm) * cosw
     &      + g1**2 * sinw * dotrc(pwp,a) * dotrc(pwm,wp) * dotcc(z,wm) * cosw
     &      - gw**2 * sinw * dotrc(pwp,a) * dotrc(pwm,wp) * dotcc(z,wm) * cosw
     &      - g1**2 * sinw * dotrc(pwp,z) * dotrc(pwm,a) * dotcc(wp,wm) * cosw
     &      + gw**2 * sinw * dotrc(pwp,z) * dotrc(pwm,a) * dotcc(wp,wm) * cosw
     &      - g1**2 * sinw * dotrc(pwp,a) * dotrc(pwm,z) * dotcc(wp,wm) * cosw
     &      + gw**2 * sinw * dotrc(pwp,a) * dotrc(pwm,z) * dotcc(wp,wm) * cosw
     &      + gw**2 * sinw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pa,pz) * cosw
     &      + gw**2 * sinw * dotcc(a,wp) * dotcc(z,wm) * dotrr(pa,pz) * cosw
     &      - g1**2 * sinw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pwp,pwm) * cosw
     &      + gw**2 * sinw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pwp,pwm) * cosw
     &      - g1**2 * sinw * dotcc(a,wp) * dotcc(z,wm) * dotrr(pwp,pwm) * cosw
     &      + gw**2 * sinw * dotcc(a,wp) * dotcc(z,wm) * dotrr(pwp,pwm) * cosw
     &      - g1 * gw * sin2w * dotrc(pwp,wm) * dotrc(pwm,z) * dotcc(a,wp)
     &      - g1 * gw * sin2w * dotrc(pwp,z) * dotrc(pwm,wp) * dotcc(a,wm)
     &      - g1 * gw * sin2w * dotrc(pwp,wm) * dotrc(pwm,a) * dotcc(z,wp)
     &      - g1 * gw * sin2w * dotrc(pwp,a) * dotrc(pwm,wp) * dotcc(z,wm)
     &      + g1 * gw * sin2w * dotrc(pwp,z) * dotrc(pwm,a) * dotcc(wp,wm)
     &      + g1 * gw * sin2w * dotrc(pwp,a) * dotrc(pwm,z) * dotcc(wp,wm)
     &      + g1 * gw * sin2w * dotcc(a,wm) * dotcc(z,wp) * dotrr(pwp,pwm)
     &      + g1 * gw * sin2w * dotcc(a,wp) * dotcc(z,wm) * dotrr(pwp,pwm) )
      endif

      if (fm2 .ne. 0) then
        wwza = wwza + fm2 * cosw * sinw * g1**2 * wmass**2 * dotcc(wp,wm) * 
     &   ( dotrc(pa,z) * dotrc(pz,a) - dotcc(a,z) * dotrr(pa,pz) )
      endif

      if (fm3 .ne. 0) then
        wwza = wwza + fm3 * cosw * sinw * g1**2 * wmass**2 / 4. * 
     &   ( (dotrc(pa,wm) * dotrc(pz,wp) + dotrc(pa,wp) * dotrc(pz,wm)) * dotcc(a,z)
     &   - dotrc(pa,z) * dotrc(pz,wm) * dotcc(a,wp) - dotrc(pa,z) * dotrc(pz,wp) * dotcc(a,wm)
     &   - dotrc(pa,wm) * dotrc(pz,a) * dotcc(z,wp) - dotrc(pa,wp) * dotrc(pz,a) * dotcc(z,wm)
     &   + (dotcc(a,wm) * dotcc(z,wp) + dotcc(a,wp) * dotcc(z,wm)) * dotrr(pa,pz) )
      endif

      if (fm4 .ne. 0) then
        wwza = wwza - fm4 * g1 * wmass**2 / 2. *
     &   ( -gw * dotrc(pa,wp) * dotrc(pwp,a) * dotcc(wm,z) * cos2w
     &   + gw * dotrc(pa,z) * dotrc(pz,a) * dotcc(wm,wp) * cos2w
     &   - gw * dotrc(pa,wm) * dotrc(pwm,a) * dotcc(z,wp) * cos2w
     &   + gw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pa,pwm) * cos2w
     &   - gw * dotcc(a,z) * dotcc(wm,wp) * dotrr(pa,pz) * cos2w
     &   + gw * dotcc(a,wp) * dotcc(wm,z) * dotrr(pa,pwp) * cos2w
     &   - g1 * sinw * dotrc(pz,wp) * dotrc(pwp,z) * dotcc(a,wm) * cosw
     &   - g1 * sinw * dotrc(pwm,z) * dotrc(pz,wm) * dotcc(a,wp) * cosw
     &   - g1 * sinw * dotrc(pa,wp) * dotrc(pwp,a) * dotcc(wm,z) * cosw
     &   - g1 * sinw * dotrc(pa,wm) * dotrc(pwm,a) * dotcc(z,wp) * cosw
     &   + g1 * sinw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pa,pwm) * cosw
     &   + g1 * sinw * dotcc(a,wp) * dotcc(wm,z) * dotrr(pa,pwp) * cosw
     &   + g1 * sinw * dotcc(a,wp) * dotcc(wm,z) * dotrr(pwm,pz) * cosw
     &   + g1 * sinw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pz,pwp) * cosw
     &   + gw * sin2w * dotrc(pz,wp) * dotrc(pwp,z) * dotcc(a,wm)
     &   + gw * sin2w * dotrc(pwm,z) * dotrc(pz,wm) * dotcc(a,wp)
     &   - gw * sin2w * dotrc(pa,z) * dotrc(pz,a) * dotcc(wm,wp)
     &   + gw * sin2w * dotcc(a,z) * dotcc(wm,wp) * dotrr(pa,pz)
     &   - gw * sin2w * dotcc(a,wp) * dotcc(wm,z) * dotrr(pwm,pz)
     &   - gw * sin2w * dotcc(a,wm) * dotcc(z,wp) * dotrr(pz,pwp) )
      endif

      if (fm5 .ne. 0) then
        wwza = wwza - fm5 * g1 * wmass**2 / 4. *
     &    (gw * dotrc(pa,z) * dotrc(pwm,wp) * dotcc(a,wm) * cos2w
     &   + gw * dotrc(pa,z) * dotrc(pz,wp) * dotcc(a,wm) * cos2w
     &   - gw * dotrc(pa,wp) * dotrc(pwp,z) * dotcc(a,wm) * cos2w
     &   - gw * dotrc(pa,wm) * dotrc(pwm,wp) * dotcc(a,z) * cos2w
     &   - gw * dotrc(pa,wm) * dotrc(pz,wp) * dotcc(a,z) * cos2w
     &   + gw * dotrc(pa,wm) * dotrc(pwp,z) * dotcc(a,wp) * cos2w
     &   - gw * dotrc(pa,z) * dotrc(pwm,a) * dotcc(wm,wp) * cos2w
     &   + gw * dotrc(pa,wm) * dotrc(pz,a) * dotcc(z,wp) * cos2w
     &   - gw * dotrc(pa,wm) * dotrc(pwp,a) * dotcc(z,wp) * cos2w
     &   + gw * dotcc(a,z) * dotcc(wm,wp) * dotrr(pa,pwm) * cos2w
     &   - gw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pa,pz) * cos2w
     &   + gw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pa,pwp) * cos2w
     &   + g1 * sinw * dotrc(pa,z) * dotrc(pwm,wp) * dotcc(a,wm) * cosw
     &   - g1 * sinw * dotrc(pa,wp) * dotrc(pwp,z) * dotcc(a,wm) * cosw
     &   - g1 * sinw * dotrc(pa,wm) * dotrc(pwm,wp) * dotcc(a,z) * cosw
     &   - g1 * sinw * dotrc(pwm,wp) * dotrc(pz,wm) * dotcc(a,z) * cosw
     &   + g1 * sinw * dotrc(pa,wm) * dotrc(pwp,z) * dotcc(a,wp) * cosw
     &   - g1 * sinw * dotrc(pz,wm) * dotrc(pwp,z) * dotcc(a,wp) * cosw
     &   + g1 * sinw * dotrc(pwm,wp) * dotrc(pz,a) * dotcc(wm,z) * cosw
     &   - g1 * sinw * dotrc(pz,wp) * dotrc(pwp,a) * dotcc(wm,z) * cosw
     &   - g1 * sinw * dotrc(pa,z) * dotrc(pwm,a) * dotcc(wm,wp) * cosw
     &   - g1 * sinw * dotrc(pwm,z) * dotrc(pz,a) * dotcc(wm,wp) * cosw
     &   - g1 * sinw * dotrc(pa,wm) * dotrc(pwp,a) * dotcc(z,wp) * cosw
     &   + g1 * sinw * dotrc(pz,wm) * dotrc(pwp,a) * dotcc(z,wp) * cosw
     &   + g1 * sinw * dotcc(a,z) * dotcc(wm,wp) * dotrr(pa,pwm) * cosw
     &   + g1 * sinw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pa,pwp) * cosw
     &   + g1 * sinw * dotcc(a,z) * dotcc(wm,wp) * dotrr(pwm,pz) * cosw
     &   + g1 * sinw * dotcc(a,wp) * dotcc(wm,z) * dotrr(pz,pwp) * cosw
     &   + gw * sin2w * dotrc(pa,wp) * dotrc(pz,wm) * dotcc(a,z)
     &   + gw * sin2w * dotrc(pwm,wp) * dotrc(pz,wm) * dotcc(a,z)
     &   - gw * sin2w * dotrc(pa,z) * dotrc(pz,wm) * dotcc(a,wp)
     &   + gw * sin2w * dotrc(pz,wm) * dotrc(pwp,z) * dotcc(a,wp)
     &   - gw * sin2w * dotrc(pa,wp) * dotrc(pz,a) * dotcc(wm,z)
     &   - gw * sin2w * dotrc(pwm,wp) * dotrc(pz,a) * dotcc(wm,z)
     &   + gw * sin2w * dotrc(pz,wp) * dotrc(pwp,a) * dotcc(wm,z)
     &   + gw * sin2w * dotrc(pwm,z) * dotrc(pz,a) * dotcc(wm,wp)
     &   - gw * sin2w * dotrc(pz,wm) * dotrc(pwp,a) * dotcc(z,wp)
     &   + gw * sin2w * dotcc(a,wp) * dotcc(wm,z) * dotrr(pa,pz)
     &   - gw * sin2w * dotcc(a,z) * dotcc(wm,wp) * dotrr(pwm,pz)
     &   - gw * sin2w * dotcc(a,wp) * dotcc(wm,z) * dotrr(pz,pwp) )
      endif

      if (fm6 .ne. 0) then
        wwza = wwza - fm6 * wmass**2 * ( 
     &      ( (sin2w - cos2w) * g1 * gw + (gw**2 - g1**2) * sqrt(sin2w * cos2w) ) *
     &            dotrc(pwp, wm) * dotrc(pwm, wp) * dotcc(z,a)
     &      + dotcc(wp,wm) * ( sqrt(sin2w * cos2w) * gw**2 * dotrc(pa,z) * dotrc(pz,a)
     &        + dotcc(a,z) * ( dotrr(pwp,pwm) * (g1 * gw * (cos2w - sin2w) + sqrt(sin2w * cos2w) * (g1**2 - gw**2))
     &                         - dotrr(pa,pz) * sqrt(sin2w * cos2w) * gw**2 ) ) )
      endif

      if (fm7 .ne. 0) then
        wwza = wwza + fm7 * wmass**2 / 4. *
     &    (g1 * gw * dotrc(pwm,z) * dotrc(pz,wp) * dotcc(a,wm) * cos2w
     &   + g1 * gw * dotrc(pwm,wp) * dotrc(pwp,z) * dotcc(a,wm) * cos2w
     &   - g1 * gw * dotrc(pwm,wp) * dotrc(pz,wm) * dotcc(a,z) * cos2w
     &   - g1 * gw * dotrc(pz,wp) * dotrc(pwp,wm) * dotcc(a,z) * cos2w
     &   + g1 * gw * dotrc(pwm,z) * dotrc(pwp,wm) * dotcc(a,wp) * cos2w
     &   + g1 * gw * dotrc(pz,wm) * dotrc(pwp,z) * dotcc(a,wp) * cos2w
     &   + g1 * gw * dotrc(pwm,wp) * dotrc(pz,a) * dotcc(wm,z) * cos2w
     &   - g1 * gw * dotrc(pwm,a) * dotrc(pz,wp) * dotcc(wm,z) * cos2w
     &   + g1 * gw * dotrc(pwm,wp) * dotrc(pwp,a) * dotcc(wm,z) * cos2w
     &   + g1 * gw * dotrc(pz,wp) * dotrc(pwp,a) * dotcc(wm,z) * cos2w
     &   - g1 * gw * dotrc(pwm,z) * dotrc(pz,a) * dotcc(wm,wp) * cos2w
     &   - g1 * gw * dotrc(pwm,z) * dotrc(pwp,a) * dotcc(wm,wp) * cos2w
     &   - g1 * gw * dotrc(pwm,a) * dotrc(pwp,z) * dotcc(wm,wp) * cos2w
     &   - g1 * gw * dotrc(pz,a) * dotrc(pwp,z) * dotcc(wm,wp) * cos2w
     &   + g1 * gw * dotrc(pwm,a) * dotrc(pz,wm) * dotcc(z,wp) * cos2w
     &   - g1 * gw * dotrc(pz,wm) * dotrc(pwp,a) * dotcc(z,wp) * cos2w
     &   + g1 * gw * dotrc(pwm,a) * dotrc(pwp,wm) * dotcc(z,wp) * cos2w
     &   + g1 * gw * dotrc(pz,a) * dotrc(pwp,wm) * dotcc(z,wp) * cos2w
     &   + g1 * gw * dotcc(a,z) * dotcc(wm,wp) * dotrr(pwm,pz) * cos2w
     &   - g1 * gw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pwm,pz) * cos2w
     &   - g1 * gw * dotcc(a,wp) * dotcc(wm,z) * dotrr(pwm,pwp) * cos2w
     &   - g1 * gw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pwm,pwp) * cos2w
     &   - g1 * gw * dotcc(a,wp) * dotcc(wm,z) * dotrr(pz,pwp) * cos2w
     &   + g1 * gw * dotcc(a,z) * dotcc(wm,wp) * dotrr(pz,pwp) * cos2w
     &   - gw**2 * sinw * dotrc(pwm,z) * dotrc(pz,wp) * dotcc(a,wm) * cosw
     &   + g1**2 * sinw * dotrc(pwm,wp) * dotrc(pwp,z) * dotcc(a,wm) * cosw
     &   - gw**2 * sinw * dotrc(pwm,wp) * dotrc(pwp,z) * dotcc(a,wm) * cosw
     &   + gw**2 * sinw * dotrc(pa,wm) * dotrc(pwm,wp) * dotcc(a,z) * cosw
     &   + gw**2 * sinw * dotrc(pwm,wp) * dotrc(pz,wm) * dotcc(a,z) * cosw
     &   + gw**2 * sinw * dotrc(pa,wm) * dotrc(pz,wp) * dotcc(a,z) * cosw
     &   + gw**2 * sinw * dotrc(pz,wp) * dotrc(pwp,wm) * dotcc(a,z) * cosw
     &   - gw**2 * sinw * dotrc(pa,wm) * dotrc(pwm,z) * dotcc(a,wp) * cosw
     &   + g1**2 * sinw * dotrc(pwm,z) * dotrc(pwp,wm) * dotcc(a,wp) * cosw
     &   - gw**2 * sinw * dotrc(pwm,z) * dotrc(pwp,wm) * dotcc(a,wp) * cosw
     &   + gw**2 * sinw * dotrc(pa,wm) * dotrc(pwp,z) * dotcc(a,wp) * cosw
     &   - gw**2 * sinw * dotrc(pz,wm) * dotrc(pwp,z) * dotcc(a,wp) * cosw
     &   - gw**2 * sinw * dotrc(pwm,wp) * dotrc(pz,a) * dotcc(wm,z) * cosw
     &   + gw**2 * sinw * dotrc(pwm,a) * dotrc(pz,wp) * dotcc(wm,z) * cosw
     &   + g1**2 * sinw * dotrc(pwm,wp) * dotrc(pwp,a) * dotcc(wm,z) * cosw
     &   - gw**2 * sinw * dotrc(pwm,wp) * dotrc(pwp,a) * dotcc(wm,z) * cosw
     &   - gw**2 * sinw * dotrc(pz,wp) * dotrc(pwp,a) * dotcc(wm,z) * cosw
     &   + gw**2 * sinw * dotrc(pwm,z) * dotrc(pz,a) * dotcc(wm,wp) * cosw
     &   - g1**2 * sinw * dotrc(pwm,z) * dotrc(pwp,a) * dotcc(wm,wp) * cosw
     &   + gw**2 * sinw * dotrc(pwm,z) * dotrc(pwp,a) * dotcc(wm,wp) * cosw
     &   - g1**2 * sinw * dotrc(pwm,a) * dotrc(pwp,z) * dotcc(wm,wp) * cosw
     &   + gw**2 * sinw * dotrc(pwm,a) * dotrc(pwp,z) * dotcc(wm,wp) * cosw
     &   + gw**2 * sinw * dotrc(pz,a) * dotrc(pwp,z) * dotcc(wm,wp) * cosw
     &   - gw**2 * sinw * dotrc(pa,wm) * dotrc(pz,a) * dotcc(z,wp) * cosw
     &   - gw**2 * sinw * dotrc(pwm,a) * dotrc(pz,wm) * dotcc(z,wp) * cosw
     &   - gw**2 * sinw * dotrc(pa,wm) * dotrc(pwp,a) * dotcc(z,wp) * cosw
     &   + gw**2 * sinw * dotrc(pz,wm) * dotrc(pwp,a) * dotcc(z,wp) * cosw
     &   + g1**2 * sinw * dotrc(pwm,a) * dotrc(pwp,wm) * dotcc(z,wp) * cosw
     &   - gw**2 * sinw * dotrc(pwm,a) * dotrc(pwp,wm) * dotcc(z,wp) * cosw
     &   - gw**2 * sinw * dotrc(pz,a) * dotrc(pwp,wm) * dotcc(z,wp) * cosw
     &   + gw**2 * sinw * dotcc(a,wp) * dotcc(wm,z) * dotrr(pa,pwm) * cosw
     &   - gw**2 * sinw * dotcc(a,z) * dotcc(wm,wp) * dotrr(pa,pwm) * cosw
     &   + gw**2 * sinw * dotcc(a,wp) * dotcc(wm,z) * dotrr(pa,pz) * cosw
     &   + gw**2 * sinw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pa,pz) * cosw
     &   - gw**2 * sinw * dotcc(a,z) * dotcc(wm,wp) * dotrr(pa,pwp) * cosw
     &   + gw**2 * sinw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pa,pwp) * cosw
     &   - gw**2 * sinw * dotcc(a,z) * dotcc(wm,wp) * dotrr(pwm,pz) * cosw
     &   + gw**2 * sinw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pwm,pz) * cosw
     &   - g1**2 * sinw * dotcc(a,wp) * dotcc(wm,z) * dotrr(pwm,pwp) * cosw
     &   + gw**2 * sinw * dotcc(a,wp) * dotcc(wm,z) * dotrr(pwm,pwp) * cosw
     &   - g1**2 * sinw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pwm,pwp) * cosw
     &   + gw**2 * sinw * dotcc(a,wm) * dotcc(z,wp) * dotrr(pwm,pwp) * cosw
     &   + gw**2 * sinw * dotcc(a,wp) * dotcc(wm,z) * dotrr(pz,pwp) * cosw
     &   - gw**2 * sinw * dotcc(a,z) * dotcc(wm,wp) * dotrr(pz,pwp) * cosw
     &   - g1 * gw * sin2w * dotrc(pwm,wp) * dotrc(pwp,z) * dotcc(a,wm)
     &   + g1 * gw * sin2w * dotrc(pa,wm) * dotrc(pwm,wp) * dotcc(a,z)
     &   - g1 * gw * sin2w * dotrc(pa,wm) * dotrc(pwm,z) * dotcc(a,wp)
     &   - g1 * gw * sin2w * dotrc(pwm,z) * dotrc(pwp,wm) * dotcc(a,wp)
     &   + g1 * gw * sin2w * dotrc(pa,wm) * dotrc(pwp,z) * dotcc(a,wp)
     &   - g1 * gw * sin2w * dotrc(pwm,wp) * dotrc(pwp,a) * dotcc(wm,z)
     &   + gw * sinw * dotrc(pa,wp) * ((cosw * gw + g1 * sinw) * dotrc(pwm,z) * dotcc(a,wm)
     &         - (cosw * gw + g1 * sinw) * dotrc(pwp,z) * dotcc(a,wm)
     &         + cosw * gw * dotrc(pz,wm) * dotcc(a,z)
     &         + cosw * gw * dotrc(pwp,wm) * dotcc(a,z)
     &         + g1 * sinw * dotrc(pwp,wm) * dotcc(a,z)
     &         - cosw * gw * dotrc(pwm,a) * dotcc(wm,z)
     &         - g1 * sinw * dotrc(pwm,a) * dotcc(wm,z)
     &         - cosw * gw * dotrc(pz,a) * dotcc(wm,z) )
     &   + g1 * gw * sin2w * dotrc(pwm,z) * dotrc(pwp,a) * dotcc(wm,wp)
     &   + g1 * gw * sin2w * dotrc(pwm,a) * dotrc(pwp,z) * dotcc(wm,wp)
     &   - gw * sinw * dotrc(pa,z) * ((cosw * gw + g1 * sinw) * dotrc(pwm,wp) * dotcc(a,wm)
     &         + cosw * gw * dotrc(pz,wp) * dotcc(a,wm)
     &         + cosw * gw * dotrc(pz,wm) * dotcc(a,wp)
     &         + cosw * gw * dotrc(pwp,wm) * dotcc(a,wp)
     &         + g1 * sinw * dotrc(pwp,wm) * dotcc(a,wp)
     &         - cosw * gw * dotrc(pwm,a) * dotcc(wm,wp)
     &         - g1 * sinw * dotrc(pwm,a) * dotcc(wm,wp)
     &         - cosw * gw * dotrc(pwp,a) * dotcc(wm,wp)
     &         - g1 * sinw * dotrc(pwp,a) * dotcc(wm,wp) )
     &   - g1 * gw * sin2w * dotrc(pa,wm) * dotrc(pwp,a) * dotcc(z,wp)
     &   - g1 * gw * sin2w * dotrc(pwm,a) * dotrc(pwp,wm) * dotcc(z,wp)
     &   + g1 * gw * sin2w * dotcc(a,wp) * dotcc(wm,z) * dotrr(pa,pwm)
     &   - g1 * gw * sin2w * dotcc(a,z) * dotcc(wm,wp) * dotrr(pa,pwm)
     &   - g1 * gw * sin2w * dotcc(a,z) * dotcc(wm,wp) * dotrr(pa,pwp)
     &   + g1 * gw * sin2w * dotcc(a,wm) * dotcc(z,wp) * dotrr(pa,pwp)
     &   + g1 * gw * sin2w * dotcc(a,wp) * dotcc(wm,z) * dotrr(pwm,pwp)
     &   + g1 * gw * sin2w * dotcc(a,wm) * dotcc(z,wp) * dotrr(pwm,pwp) )
      endif

      if (fwww .ne. 0) then
        wwza = wwza - fwww * 3./2. * gw**4 * sqrt(sin2w*cos2w) * 
     &      ( (dotrc(pz,a)*(dotrc(pwm,z)+dotrc(pwp,z)) + dotrc(pa,z)*(dotrc(pwm,a)+dotrc(pwp,a))) * dotcc(wp,wm)
     &      - dotcc(a,z) * dotcc(wp,wm) * ( dotrr(pwm,pa) + dotrr(pwm,pz) + dotrr(pwp,pa) + dotrr(pwp,pz) )
     &      - dotcc(z,wm) * ( dotrc(pz,a)*dotrc(pwm,wp) + dotrc(pwm,a)*(dotrc(pa,wp)-dotrc(pz,wp))
     &                      + dotrc(pwp,a)*dotrc(pz,wp) )
     &      - dotcc(a,wm) * ( dotrc(pa,z)*dotrc(pwm,wp) + dotrc(pwp,z)*dotrc(pa,wp)
     &                      + dotrc(pwm,z)*(dotrc(pz,wp)-dotrc(pa,wp)) )
     &      - dotcc(z,wp) * ( dotrc(pz,a)*dotrc(pwp,wm) + dotrc(pwp,a)*(dotrc(pa,wm)-dotrc(pz,wm))
     &                      + dotrc(pwm,a)*dotrc(pz,wm) )
     &      - dotcc(a,wp) * ( dotrc(pa,z)*dotrc(pwp,wm) + dotrc(pwm,z)*dotrc(pa,wm)
     &                      + dotrc(pwp,z)*(dotrc(pz,wm)-dotrc(pa,wm)) )
     &      + dotcc(a,z) * ( (dotrc(pa,wp)+dotrc(pz,wp))*dotrc(pwp,wm) + dotrc(pwm,wp)*(dotrc(pa,wm)+dotrc(pz,wm)) )
     &      + dotcc(a,wm) * dotcc(z,wp) * ( dotrr(pwm,pz) + dotrr(pwp,pa) )
     &      + dotcc(a,wp) * dotcc(z,wm) * ( dotrr(pwm,pa) + dotrr(pwp,pz) ) )
      endif

      if (fw .ne. 0) then
        wwza = wwza + fw * gw**2 * wmass**2 * sqrt(sin2w/cos2w) / 2. * ( - 2.*dotcc(a,z)*dotcc(wm,wp)
     &      + dotcc(a,wp)*dotcc(z,wm) + dotcc(a,wm)*dotcc(z,wp) )
      endif

      return
      end



      subroutine wwzz_anomal8(wm,z1,wp,z2, wwzz)
c
c This subroutine computes the wwzz-vertex with anomalous couplings
c     
      implicit none
      double complex wp(6),wm(6),z1(6),z2(6),wwzz, dotcc, dotrc
      double precision pwp(0:3),pwm(0:3),pz1(0:3),pz2(0:3), dotrr
      double precision cos2w, g1, cosw, sinw
      integer i
      external dotcc, dotrc, dotrr

#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/an_couplings.inc"   

      cos2w=1.0d0 - sin2w
      cosw = sqrt(cos2w)
      sinw = sqrt(sin2w)
      g1 = ee / cosw

      pwm(0) = dble( wm(5))
      pwm(1) = dble( wm(6))
      pwm(2) = dimag(wm(6))
      pwm(3) = dimag(wm(5))
      pwp(0) = dble( wp(5))
      pwp(1) = dble( wp(6))
      pwp(2) = dimag(wp(6))
      pwp(3) = dimag(wp(5))
      pz1(0) = dble( z1(5))
      pz1(1) = dble( z1(6))
      pz1(2) = dimag(z1(6))
      pz1(3) = dimag(z1(5))
      pz2(0) = dble( z2(5))
      pz2(1) = dble( z2(6))
      pz2(2) = dimag(z2(6))
      pz2(3) = dimag(z2(5))

      wwzz = gwwz**2 * (dotcc(wm,z1)*dotcc(wp,z2) + dotcc(wm,z2)*dotcc(wp,z1) - 2.0d0*dotcc(wm,wp)*dotcc(z1,z2))

      if (fs0 .ne. 0) then
        wwzz = wwzz + fs0 * wmass**4 / cos2w * (dotcc(wm,z1)*dotcc(wp,z2) + dotcc(wm,z2)*dotcc(wp,z1))
      endif

      if (fs1 .ne. 0) then
        wwzz = wwzz + fs1 * wmass**4 / cos2w * 2.0d0 * dotcc(wm,wp)*dotcc(z1,z2)
      endif

      if (ft0 .ne. 0) then
        wwzz = wwzz + ft0 * 8. * gw**4 * cos2w * ( dotrc(pwp,wm)*dotrc(pwm,wp) - dotcc(wp,wm)*dotrr(pwp,pwm) )
     &   * ( dotrc(pz1,z2)*dotrc(pz2,z1) - dotcc(z1,z2)*dotrr(pz1,pz2) )
      endif

      if (ft1 .ne. 0) then
        wwzz = wwzz + ft1 * 4. * gw**4 * cos2w * 
     &   ( dotrc(pwp,z2)*dotrc(pwm,z1)*dotrc(pz1,wm)*dotrc(pz2,wp) - dotrc(pwp,z2)*dotcc(wm,z1)*dotrr(pwm,pz1)*dotrc(pz2,wp) 
     &   + dotrc(pwp,z1)*dotrc(pwm,z2)*dotrc(pz1,wp)*dotrc(pz2,wm) - dotrc(pwm,z2)*dotrc(pz2,wm)*dotcc(wp,z1)*dotrr(pwp,pz1) 
     &   - dotrc(pwm,z1)*dotrc(pz1,wm)*dotcc(wp,z2)*dotrr(pwp,pz2) + dotcc(wp,z2)*dotcc(wm,z1)*dotrr(pwp,pz2)*dotrr(pwm,pz1)
     &   - dotrc(pwp,z1)*dotrc(pz1,wp)*dotcc(wm,z2)*dotrr(pwm,pz2) + dotcc(wp,z1)*dotcc(wm,z2)*dotrr(pwp,pz1)*dotrr(pwm,pz2) )
      endif

      if (ft2 .ne. 0) then
        wwzz = wwzz + cos2w * ft2 * gw**4 *
     &   ( dotrc(pwp,wm) * dotrc(pwm,z1) * dotrc(pz1,z2) * dotrc(pz2,wp)
     &   - dotrc(pz1,z2) * dotcc(wm,z1) * dotrr(pwp,pwm) * dotrc(pz2,wp)
     &   + dotrc(pz1,wm) * dotcc(z1,z2) * dotrr(pwp,pwm) * dotrc(pz2,wp)
     &   - dotrc(pwp,wm) * dotcc(z1,z2) * dotrr(pwm,pz1) * dotrc(pz2,wp)
     &   + dotrc(pwp,z1) * dotrc(pwm,wp) * dotrc(pz1,z2) * dotrc(pz2,wm)
     &   + dotrc(pwp,wm) * dotrc(pwm,z2) * dotrc(pz1,wp) * dotrc(pz2,z1)
     &   + dotrc(pwp,z2) * dotrc(pwm,wp) * dotrc(pz1,wm) * dotrc(pz2,z1)
     &   - dotrc(pz1,z2) * dotrc(pz2,wm) * dotcc(wp,z1) * dotrr(pwp,pwm)
     &   - dotrc(pz1,wm) * dotrc(pz2,z1) * dotcc(wp,z2) * dotrr(pwp,pwm)
     &   - dotrc(pz1,wp) * dotrc(pz2,z1) * dotcc(wm,z2) * dotrr(pwp,pwm)
     &   + dotrc(pz1,wp) * dotrc(pz2,wm) * dotcc(z1,z2) * dotrr(pwp,pwm)
     &   - dotrc(pwm,z2) * dotrc(pz2,z1) * dotcc(wp,wm) * dotrr(pwp,pz1)
     &   + dotrc(pwm,wp) * dotrc(pz2,z1) * dotcc(wm,z2) * dotrr(pwp,pz1)
     &   - dotrc(pwm,wp) * dotrc(pz2,wm) * dotcc(z1,z2) * dotrr(pwp,pz1)
     &   - dotrc(pwm,z1) * dotrc(pz1,z2) * dotcc(wp,wm) * dotrr(pwp,pz2)
     &   + dotrc(pwm,wp) * dotrc(pz1,z2) * dotcc(wm,z1) * dotrr(pwp,pz2)
     &   - dotrc(pwm,wp) * dotrc(pz1,wm) * dotcc(z1,z2) * dotrr(pwp,pz2)
     &   - dotrc(pwp,z2) * dotrc(pz2,z1) * dotcc(wp,wm) * dotrr(pwm,pz1)
     &   + dotrc(pwp,wm) * dotrc(pz2,z1) * dotcc(wp,z2) * dotrr(pwm,pz1)
     &   + dotcc(wp,wm) * dotcc(z1,z2) * dotrr(pwp,pz2) * dotrr(pwm,pz1)
     &   - dotrc(pwp,z1) * dotrc(pz1,z2) * dotcc(wp,wm) * dotrr(pwm,pz2)
     &   + dotrc(pwp,wm) * dotrc(pz1,z2) * dotcc(wp,z1) * dotrr(pwm,pz2)
     &   - dotrc(pwp,wm) * dotrc(pz1,wp) * dotcc(z1,z2) * dotrr(pwm,pz2)
     &   + dotcc(wp,wm) * dotcc(z1,z2) * dotrr(pwp,pz1) * dotrr(pwm,pz2)
     &   + dotrc(pwp,z2) * dotrc(pwm,z1) * dotcc(wp,wm) * dotrr(pz1,pz2)
     &   + dotrc(pwp,z1) * dotrc(pwm,z2) * dotcc(wp,wm) * dotrr(pz1,pz2)
     &   - dotrc(pwp,wm) * dotrc(pwm,z2) * dotcc(wp,z1) * dotrr(pz1,pz2)
     &   - dotrc(pwp,wm) * dotrc(pwm,z1) * dotcc(wp,z2) * dotrr(pz1,pz2)
     &   - dotrc(pwp,z2) * dotrc(pwm,wp) * dotcc(wm,z1) * dotrr(pz1,pz2)
     &   - dotrc(pwp,z1) * dotrc(pwm,wp) * dotcc(wm,z2) * dotrr(pz1,pz2)
     &   + dotcc(wp,z2) * dotcc(wm,z1) * dotrr(pwp,pwm) * dotrr(pz1,pz2)
     &   + dotcc(wp,z1) * dotcc(wm,z2) * dotrr(pwp,pwm) * dotrr(pz1,pz2) )
      endif

      if (ft5 .ne. 0) then
        wwzz = wwzz + ft5 * 2. * ee**2 / cos2w * gw**2 * sin2w * ( dotrc(pwp,wm)*dotrc(pwm,wp) - dotcc(wp,wm)*dotrr(pwp,pwm) )
     &   * ( dotrc(pz1,z2)*dotrc(pz2,z1) - dotcc(z1,z2)*dotrr(pz1,pz2) )
      endif

      if (ft6 .ne. 0) then
        wwzz = wwzz + ft6 * g1**2 * gw**2 * sin2w * 
     &   ( dotrc(pwp,z2)*dotrc(pwm,z1)*dotrc(pz1,wm)*dotrc(pz2,wp) - dotrc(pwp,z2)*dotrc(pz2,wp)*dotcc(wm,z1)*dotrr(pwm,pz1)
     &   + dotrc(pwp,z1)*dotrc(pwm,z2)*dotrc(pz1,wp)*dotrc(pz2,wm) - dotrc(pwm,z2)*dotrc(pz2,wm)*dotcc(wp,z1)*dotrr(pwp,pz1)
     &   - dotrc(pwm,z1)*dotrc(pz1,wm)*dotcc(wp,z2)*dotrr(pwp,pz2) + dotcc(wp,z2)*dotcc(wm,z1)*dotrr(pwp,pz2)*dotrr(pwm,pz1)
     &   - dotrc(pwp,z1)*dotrc(pz1,wp)*dotcc(wm,z2)*dotrr(pwm,pz2) + dotcc(wp,z1)*dotcc(wm,z2)*dotrr(pwp,pz1)*dotrr(pwm,pz2) )
      endif

      if (ft7 .ne. 0) then
        wwzz = wwzz + ft7 * g1**2 * gw**2 * sin2w / 4. *
     &   ( dotrc(pwp,wm) * dotrc(pwm,z1) * dotrc(pz1,z2) * dotrc(pz2,wp)
     &   - dotrc(pz1,z2) * dotcc(wm,z1) * dotrr(pwp,pwm) * dotrc(pz2,wp)
     &   + dotrc(pz1,wm) * dotcc(z1,z2) * dotrr(pwp,pwm) * dotrc(pz2,wp)
     &   - dotrc(pwp,wm) * dotcc(z1,z2) * dotrr(pwm,pz1) * dotrc(pz2,wp)
     &   + dotrc(pwp,z1) * dotrc(pwm,wp) * dotrc(pz1,z2) * dotrc(pz2,wm)
     &   + dotrc(pwp,wm) * dotrc(pwm,z2) * dotrc(pz1,wp) * dotrc(pz2,z1)
     &   + dotrc(pwp,z2) * dotrc(pwm,wp) * dotrc(pz1,wm) * dotrc(pz2,z1)
     &   - dotrc(pz1,z2) * dotrc(pz2,wm) * dotcc(wp,z1) * dotrr(pwp,pwm)
     &   - dotrc(pz1,wm) * dotrc(pz2,z1) * dotcc(wp,z2) * dotrr(pwp,pwm)
     &   - dotrc(pz1,wp) * dotrc(pz2,z1) * dotcc(wm,z2) * dotrr(pwp,pwm)
     &   + dotrc(pz1,wp) * dotrc(pz2,wm) * dotcc(z1,z2) * dotrr(pwp,pwm)
     &   - dotrc(pwm,z2) * dotrc(pz2,z1) * dotcc(wp,wm) * dotrr(pwp,pz1)
     &   + dotrc(pwm,wp) * dotrc(pz2,z1) * dotcc(wm,z2) * dotrr(pwp,pz1)
     &   - dotrc(pwm,wp) * dotrc(pz2,wm) * dotcc(z1,z2) * dotrr(pwp,pz1)
     &   - dotrc(pwm,z1) * dotrc(pz1,z2) * dotcc(wp,wm) * dotrr(pwp,pz2)
     &   + dotrc(pwm,wp) * dotrc(pz1,z2) * dotcc(wm,z1) * dotrr(pwp,pz2)
     &   - dotrc(pwm,wp) * dotrc(pz1,wm) * dotcc(z1,z2) * dotrr(pwp,pz2)
     &   - dotrc(pwp,z2) * dotrc(pz2,z1) * dotcc(wp,wm) * dotrr(pwm,pz1)
     &   + dotrc(pwp,wm) * dotrc(pz2,z1) * dotcc(wp,z2) * dotrr(pwm,pz1)
     &   + dotcc(wp,wm) * dotcc(z1,z2) * dotrr(pwp,pz2) * dotrr(pwm,pz1)
     &   - dotrc(pwp,z1) * dotrc(pz1,z2) * dotcc(wp,wm) * dotrr(pwm,pz2)
     &   + dotrc(pwp,wm) * dotrc(pz1,z2) * dotcc(wp,z1) * dotrr(pwm,pz2)
     &   - dotrc(pwp,wm) * dotrc(pz1,wp) * dotcc(z1,z2) * dotrr(pwm,pz2)
     &   + dotcc(wp,wm) * dotcc(z1,z2) * dotrr(pwp,pz1) * dotrr(pwm,pz2)
     &   + dotrc(pwp,z2) * dotrc(pwm,z1) * dotcc(wp,wm) * dotrr(pz1,pz2)
     &   + dotrc(pwp,z1) * dotrc(pwm,z2) * dotcc(wp,wm) * dotrr(pz1,pz2)
     &   - dotrc(pwp,wm) * dotrc(pwm,z2) * dotcc(wp,z1) * dotrr(pz1,pz2)
     &   - dotrc(pwp,wm) * dotrc(pwm,z1) * dotcc(wp,z2) * dotrr(pz1,pz2)
     &   - dotrc(pwp,z2) * dotrc(pwm,wp) * dotcc(wm,z1) * dotrr(pz1,pz2)
     &   - dotrc(pwp,z1) * dotrc(pwm,wp) * dotcc(wm,z2) * dotrr(pz1,pz2)
     &   + dotcc(wp,z2) * dotcc(wm,z1) * dotrr(pwp,pwm) * dotrr(pz1,pz2)
     &   + dotcc(wp,z1) * dotcc(wm,z2) * dotrr(pwp,pwm) * dotrr(pz1,pz2) )
      endif

      if (fm0 .ne. 0) then
        wwzz = wwzz - fm0 * 2. * wmass**2 * (
     &        cos2w * gw**2 * dotrc(pwp,wm) * dotrc(pwm,wp) * dotcc(z1,z2)
     &      + cos2w * gw**2 * dotrc(pz1,z2) * dotrc(pz2,z1) * dotcc(wp,wm)
     &      - cos2w * gw**2 * dotrr(pz1,pz2) * dotcc(z1,z2) * dotcc(wp,wm)
     &      - cos2w * gw**2 * dotrr(pwp,pwm) * dotcc(z1,z2) * dotcc(wp,wm)
     &      + 2. * cosw * sinw * g1 * gw * dotrc(pwp,wm) * dotrc(pwm,wp) * dotcc(z1,z2)
     &      - 2. * cosw * sinw * g1 * gw * dotcc(wp,wm) * dotcc(z1,z2) * dotrr(pwp,pwm)
     &      + sin2w * g1**2 * dotrc(pwp,wm) * dotrc(pwm,wp) * dotcc(z1,z2)
     &      - sin2w * g1**2 * dotrr(pwp,pwm) * dotcc(z1,z2) * dotcc(wp,wm) )
      endif

      if (fm1 .ne. 0) then
        wwzz = wwzz + fm1 * wmass**2 / 2. *
     &   ( cos2w * dotrc(pz1,z2) * dotrc(pz2,wm) * dotcc(z1,wp) * gw**2
     &   + cos2w * dotrc(pwp,wm) * dotrc(pwm,z2) * dotcc(z1,wp) * gw**2
     &   + cos2w * dotrc(pz1,z2) * dotrc(pz2,wp) * dotcc(z1,wm) * gw**2
     &   + cos2w * dotrc(pwp,z2) * dotrc(pwm,wp) * dotcc(z1,wm) * gw**2
     &   + cos2w * dotrc(pwp,wm) * dotrc(pwm,z1) * dotcc(z2,wp) * gw**2
     &   + cos2w * dotrc(pz1,wm) * (dotrc(pz2,z1) * dotcc(z2,wp) - dotrc(pz2,wp) * dotcc(z1,z2)) * gw**2
     &   + cos2w * dotrc(pwp,z1) * dotrc(pwm,wp) * dotcc(z2,wm) * gw**2
     &   + cos2w * dotrc(pz1,wp) * (dotrc(pz2,z1) * dotcc(z2,wm) - dotrc(pz2,wm) * dotcc(z1,z2)) * gw**2
     &   - cos2w * dotrc(pwp,z2) * dotrc(pwm,z1) * dotcc(wp,wm) * gw**2
     &   - cos2w * dotrc(pwp,z1) * dotrc(pwm,z2) * dotcc(wp,wm) * gw**2
     &   - cos2w * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz1,pz2) * gw**2
     &   - cos2w * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pz1,pz2) * gw**2
     &   - cos2w * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pwp,pwm) * gw**2
     &   - cos2w * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pwp,pwm) * gw**2
     &   + 2. * cosw * g1 * sinw * dotrc(pwp,wm) * dotrc(pwm,z2) * dotcc(z1,wp) * gw
     &   + 2. * cosw * g1 * sinw * dotrc(pwp,z2) * dotrc(pwm,wp) * dotcc(z1,wm) * gw
     &   + 2. * cosw * g1 * sinw * dotrc(pwp,wm) * dotrc(pwm,z1) * dotcc(z2,wp) * gw
     &   + 2. * cosw * g1 * sinw * dotrc(pwp,z1) * dotrc(pwm,wp) * dotcc(z2,wm) * gw
     &   - 2. * cosw * g1 * sinw * dotrc(pwp,z2) * dotrc(pwm,z1) * dotcc(wp,wm) * gw
     &   - 2. * cosw * g1 * sinw * dotrc(pwp,z1) * dotrc(pwm,z2) * dotcc(wp,wm) * gw
     &   - 2. * cosw * g1 * sinw * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pwp,pwm) * gw
     &   - 2. * cosw * g1 * sinw * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pwp,pwm) * gw
     &   + g1**2 * sin2w * dotrc(pwp,wm) * dotrc(pwm,z2) * dotcc(z1,wp)
     &   + g1**2 * sin2w * dotrc(pwp,z2) * dotrc(pwm,wp) * dotcc(z1,wm)
     &   + g1**2 * sin2w * dotrc(pwp,wm) * dotrc(pwm,z1) * dotcc(z2,wp)
     &   + g1**2 * sin2w * dotrc(pwp,z1) * dotrc(pwm,wp) * dotcc(z2,wm)
     &   - g1**2 * sin2w * dotrc(pwp,z2) * dotrc(pwm,z1) * dotcc(wp,wm)
     &   - g1**2 * sin2w * dotrc(pwp,z1) * dotrc(pwm,z2) * dotcc(wp,wm)
     &   - g1**2 * sin2w * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pwp,pwm)
     &   - g1**2 * sin2w * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pwp,pwm) )
      endif

      if (fm2 .ne. 0) then
        wwzz = wwzz - fm2 * sin2w * g1**2 * wmass**2 * dotcc(wp,wm) * 
     &   ( dotrc(pz1,z2) * dotrc(pz2,z1) - dotcc(z1,z2) * dotrr(pz1,pz2) )
      endif

      if (fm3 .ne. 0) then
        wwzz = wwzz - fm3 * sin2w * g1**2 * wmass**2 / 4. * 
     &   ( (dotrc(pz1,wm) * dotrc(pz2,wp) + dotrc(pz1,wp) * dotrc(pz2,wm)) * dotcc(z1,z2)
     &   - dotrc(pz1,z2) * dotrc(pz2,wm) * dotcc(z1,wp) - dotrc(pz1,z2) * dotrc(pz2,wp) * dotcc(z1,wm)
     &   - dotrc(pz1,wm) * dotrc(pz2,z1) * dotcc(z2,wp) - dotrc(pz1,wp) * dotrc(pz2,z1) * dotcc(z2,wm)
     &   + (dotcc(z1,wm) * dotcc(z2,wp) + dotcc(z1,wp) * dotcc(z2,wm)) * dotrr(pz1,pz2) )
      endif

      if (fm4 .ne. 0) then
        wwzz = wwzz - fm4 * g1 * sinw * wmass**2 / 2. *
     &   ( (gw / cosw) * dotrc(pz2,wm) * dotrc(pwm,z2) * dotcc(z1,wp)
     &   - cosw * gw * dotcc(z2,wm) * dotrr(pz1,pwp) * dotcc(z1,wp)
     &   - g1 * sinw * dotcc(z2,wm) * dotrr(pz1,pwp) * dotcc(z1,wp)
     &   - cosw * gw * dotcc(z2,wm) * dotrr(pz2,pwm) * dotcc(z1,wp)
     &   - g1 * sinw * dotcc(z2,wm) * dotrr(pz2,pwm) * dotcc(z1,wp)
     &   + (gw / cosw) * dotrc(pz2,wp) * dotrc(pwp,z2) * dotcc(z1,wm)
     &   + cosw * gw * dotrc(pz1,wm) * dotrc(pwm,z1) * dotcc(z2,wp)
     &   + g1 * sinw * dotrc(pz1,wm) * dotrc(pwm,z1) * dotcc(z2,wp)
     &   + cosw * gw * dotrc(pz1,wp) * dotrc(pwp,z1) * dotcc(z2,wm)
     &   + g1 * sinw * dotrc(pz1,wp) * dotrc(pwp,z1) * dotcc(z2,wm)
     &   - 2. * cosw * gw * dotrc(pz1,z2) * dotrc(pz2,z1) * dotcc(wp,wm)
     &   + 2. * cosw * gw * dotcc(z1,z2) * dotcc(wp,wm) * dotrr(pz1,pz2)
     &   - cosw * gw * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz1,pwm)
     &   - g1 * sinw * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz1,pwm)
     &   - cosw * gw * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz2,pwp)
     &   - g1 * sinw * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz2,pwp) )
      endif

      if (fm5 .ne. 0) then
        wwzz = wwzz - fm5 * g1 * wmass**2 / 4. * sinw *
     &   ( cosw * gw * dotrc(pz1,wm) * dotrc(pz2,wp) * dotcc(z1,z2)
     &   + cosw * gw * dotrc(pz1,wp) * dotrc(pz2,wm) * dotcc(z1,z2)
     &   + cosw * gw * dotrc(pz1,wm) * dotrc(pwm,wp) * dotcc(z1,z2)
     &   + g1 * sinw * dotrc(pz1,wm) * dotrc(pwm,wp) * dotcc(z1,z2)
     &   + cosw * gw * dotrc(pz2,wm) * dotrc(pwm,wp) * dotcc(z1,z2)
     &   + g1 * sinw * dotrc(pz2,wm) * dotrc(pwm,wp) * dotcc(z1,z2)
     &   - cosw * gw * dotcc(wp,wm) * dotrr(pz1,pwm) * dotcc(z1,z2)
     &   - g1 * sinw * dotcc(wp,wm) * dotrr(pz1,pwm) * dotcc(z1,z2)
     &   - cosw * gw * dotcc(wp,wm) * dotrr(pz2,pwm) * dotcc(z1,z2)
     &   - g1 * sinw * dotcc(wp,wm) * dotrr(pz2,pwm) * dotcc(z1,z2)
     &   - cosw * gw * dotrc(pz1,z2) * dotrc(pz2,wm) * dotcc(z1,wp)
     &   - cosw * gw * dotrc(pz1,wm) * dotrc(pwp,z2) * dotcc(z1,wp)
     &   - g1 * sinw * dotrc(pz1,wm) * dotrc(pwp,z2) * dotcc(z1,wp)
     &   + cosw * gw * dotrc(pz2,wm) * dotrc(pwp,z2) * dotcc(z1,wp)
     &   + g1 * sinw * dotrc(pz2,wm) * dotrc(pwp,z2) * dotcc(z1,wp)
     &   - cosw * gw * dotrc(pz1,z2) * dotrc(pz2,wp) * dotcc(z1,wm)
     &   + cosw * gw * dotrc(pz1,wp) * dotrc(pwp,z2) * dotcc(z1,wm)
     &   + g1 * sinw * dotrc(pz1,wp) * dotrc(pwp,z2) * dotcc(z1,wm)
     &   - cosw * gw * dotrc(pz1,z2) * dotrc(pwm,wp) * dotcc(z1,wm)
     &   - g1 * sinw * dotrc(pz1,z2) * dotrc(pwm,wp) * dotcc(z1,wm)
     &   - cosw * gw * dotrc(pz1,wm) * dotrc(pz2,z1) * dotcc(z2,wp)
     &   + cosw * gw * dotrc(pz1,wm) * dotrc(pwp,z1) * dotcc(z2,wp)
     &   + g1 * sinw * dotrc(pz1,wm) * dotrc(pwp,z1) * dotcc(z2,wp)
     &   - cosw * gw * dotrc(pz2,wm) * dotrc(pwp,z1) * dotcc(z2,wp)
     &   - g1 * sinw * dotrc(pz2,wm) * dotrc(pwp,z1) * dotcc(z2,wp)
     &   - cosw * gw * dotrc(pz1,wp) * dotrc(pz2,z1) * dotcc(z2,wm)
     &   + cosw * gw * dotrc(pz2,wp) * dotrc(pwp,z1) * dotcc(z2,wm)
     &   + g1 * sinw * dotrc(pz2,wp) * dotrc(pwp,z1) * dotcc(z2,wm)
     &   - cosw * gw * dotrc(pz2,z1) * dotrc(pwm,wp) * dotcc(z2,wm)
     &   - g1 * sinw * dotrc(pz2,z1) * dotrc(pwm,wp) * dotcc(z2,wm)
     &   + cosw * gw * dotrc(pz1,z2) * dotrc(pwm,z1) * dotcc(wp,wm)
     &   + g1 * sinw * dotrc(pz1,z2) * dotrc(pwm,z1) * dotcc(wp,wm)
     &   + cosw * gw * dotrc(pz2,z1) * dotrc(pwm,z2) * dotcc(wp,wm)
     &   + g1 * sinw * dotrc(pz2,z1) * dotrc(pwm,z2) * dotcc(wp,wm)
     &   + cosw * gw * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz1,pz2)
     &   + cosw * gw * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pz1,pz2)
     &   - cosw * gw * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz1,pwp)
     &   - g1 * sinw * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz1,pwp)
     &   - cosw * gw * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pz2,pwp)
     &   - g1 * sinw * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pz2,pwp) )
      endif

      if (fm6 .ne. 0) then
        wwzz = wwzz - fm6 * wmass**2 * gw**2 / cos2w * ( 
     &        dotrc(pwp,wm) * dotrc(pwm,wp) * dotcc(z1,z2)
     &      + dotcc(wp,wm) * ( cos2w**2  * dotrc(pz1,z2) * dotrc(pz2,z1)
     &            - dotcc(z1,z2) * ( cos2w**2 * dotrr(pz1,pz2) + dotrr(pwp,pwm) )))
      endif

      if (fm7 .ne. 0) then
        wwzz = wwzz + fm7 * wmass**2 / 4. *
     &    (cos2w * dotrc(pz2,wp) * dotrc(pwp,wm) * dotcc(z1,z2) * gw**2
     &   + cos2w * dotrc(pz2,wm) * dotrc(pwm,wp) * dotcc(z1,z2) * gw**2
     &   - cos2w * dotrc(pz1,z2) * dotrc(pz2,wm) * dotcc(z1,wp) * gw**2
     &   - cos2w * dotrc(pz2,wm) * dotrc(pwp,z2) * dotcc(z1,wp) * gw**2
     &   - cos2w * dotrc(pz1,z2) * dotrc(pwp,wm) * dotcc(z1,wp) * gw**2
     &   - cos2w * dotrc(pwp,wm) * dotrc(pwm,z2) * dotcc(z1,wp) * gw**2
     &   - cos2w * dotrc(pz1,z2) * dotrc(pz2,wp) * dotcc(z1,wm) * gw**2
     &   - cos2w * dotrc(pz2,wp) * dotrc(pwm,z2) * dotcc(z1,wm) * gw**2
     &   - cos2w * dotrc(pz1,z2) * dotrc(pwm,wp) * dotcc(z1,wm) * gw**2
     &   - cos2w * dotrc(pwp,z2) * dotrc(pwm,wp) * dotcc(z1,wm) * gw**2
     &   + cos2w * dotrc(pz2,wm) * dotrc(pwp,z1) * dotcc(z2,wp) * gw**2
     &   - cos2w * dotrc(pz2,z1) * dotrc(pwp,wm) * dotcc(z2,wp) * gw**2
     &   - cos2w * dotrc(pz2,wm) * dotrc(pwm,z1) * dotcc(z2,wp) * gw**2
     &   - cos2w * dotrc(pwp,wm) * dotrc(pwm,z1) * dotcc(z2,wp) * gw**2
     &   - cos2w * dotrc(pz2,wp) * dotrc(pwp,z1) * dotcc(z2,wm) * gw**2
     &   + cos2w * dotrc(pz2,wp) * dotrc(pwm,z1) * dotcc(z2,wm) * gw**2
     &   - cos2w * dotrc(pz2,z1) * dotrc(pwm,wp) * dotcc(z2,wm) * gw**2
     &   - cos2w * dotrc(pwp,z1) * dotrc(pwm,wp) * dotcc(z2,wm) * gw**2
     &   + cos2w * dotrc(pz1,z2) * dotrc(pwp,z1) * dotcc(wp,wm) * gw**2
     &   + cos2w * dotrc(pz2,z1) * dotrc(pwp,z2) * dotcc(wp,wm) * gw**2
     &   + cos2w * dotrc(pz1,z2) * dotrc(pwm,z1) * dotcc(wp,wm) * gw**2
     &   + cos2w * dotrc(pwp,z2) * dotrc(pwm,z1) * dotcc(wp,wm) * gw**2
     &   + cos2w * dotrc(pz2,z1) * dotrc(pwm,z2) * dotcc(wp,wm) * gw**2
     &   + cos2w * dotrc(pwp,z1) * dotrc(pwm,z2) * dotcc(wp,wm) * gw**2
     &   + cos2w * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz1,pz2) * gw**2
     &   + cos2w * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pz1,pz2) * gw**2
     &   + cos2w * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz1,pwp) * gw**2
     &   - cos2w * dotcc(z1,z2) * dotcc(wp,wm) * dotrr(pz1,pwp) * gw**2
     &   + cos2w * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pz1,pwm) * gw**2
     &   - cos2w * dotcc(z1,z2) * dotcc(wp,wm) * dotrr(pz1,pwm) * gw**2
     &   + cos2w * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pz2,pwp) * gw**2
     &   - cos2w * dotcc(z1,z2) * dotcc(wp,wm) * dotrr(pz2,pwp) * gw**2
     &   + cos2w * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz2,pwm) * gw**2
     &   - cos2w * dotcc(z1,z2) * dotcc(wp,wm) * dotrr(pz2,pwm) * gw**2
     &   + cos2w * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pwp,pwm) * gw**2
     &   + cos2w * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pwp,pwm) * gw**2
     &   + cosw * g1 * sinw * dotrc(pz2,wp) * dotrc(pwp,wm) * dotcc(z1,z2) * gw
     &   + cosw * g1 * sinw * dotrc(pz2,wm) * dotrc(pwm,wp) * dotcc(z1,z2) * gw
     &   - cosw * g1 * sinw * dotrc(pz2,wm) * dotrc(pwp,z2) * dotcc(z1,wp) * gw
     &   - cosw * g1 * sinw * dotrc(pz1,z2) * dotrc(pwp,wm) * dotcc(z1,wp) * gw
     &   - 2. * cosw * g1 * sinw * dotrc(pwp,wm) * dotrc(pwm,z2) * dotcc(z1,wp) * gw
     &   - cosw * g1 * sinw * dotrc(pz2,wp) * dotrc(pwm,z2) * dotcc(z1,wm) * gw
     &   - cosw * g1 * sinw * dotrc(pz1,z2) * dotrc(pwm,wp) * dotcc(z1,wm) * gw
     &   - 2. * cosw * g1 * sinw * dotrc(pwp,z2) * dotrc(pwm,wp) * dotcc(z1,wm) * gw
     &   + cosw * g1 * sinw * dotrc(pz2,wm) * dotrc(pwp,z1) * dotcc(z2,wp) * gw
     &   - cosw * g1 * sinw * dotrc(pz2,z1) * dotrc(pwp,wm) * dotcc(z2,wp) * gw
     &   - cosw * g1 * sinw * dotrc(pz2,wm) * dotrc(pwm,z1) * dotcc(z2,wp) * gw
     &   - 2. * cosw * g1 * sinw * dotrc(pwp,wm) * dotrc(pwm,z1) * dotcc(z2,wp) * gw
     &   + cosw * dotrc(pz1,wm) * (cosw * gw * dotrc(pz2,wp) * dotcc(z1,z2)
     &         + (cosw * gw + g1 * sinw) * dotrc(pwm,wp) * dotcc(z1,z2)
     &         + cosw * gw * dotrc(pwp,z2) * dotcc(z1,wp)
     &         + g1 * sinw * dotrc(pwp,z2) * dotcc(z1,wp)
     &         - cosw * gw * dotrc(pwm,z2) * dotcc(z1,wp)
     &         - g1 * sinw * dotrc(pwm,z2) * dotcc(z1,wp)
     &         - cosw * gw * dotrc(pz2,z1) * dotcc(z2,wp)
     &         - cosw * gw * dotrc(pwp,z1) * dotcc(z2,wp)
     &         - g1 * sinw * dotrc(pwp,z1) * dotcc(z2,wp) ) * gw
     &   - cosw * g1 * sinw * dotrc(pz2,wp) * dotrc(pwp,z1) * dotcc(z2,wm) * gw
     &   + cosw * g1 * sinw * dotrc(pz2,wp) * dotrc(pwm,z1) * dotcc(z2,wm) * gw
     &   - cosw * g1 * sinw * dotrc(pz2,z1) * dotrc(pwm,wp) * dotcc(z2,wm) * gw
     &   - 2. * cosw * g1 * sinw * dotrc(pwp,z1) * dotrc(pwm,wp) * dotcc(z2,wm) * gw
     &   + cosw * dotrc(pz1,wp) * (cosw * gw * dotrc(pz2,wm) * dotcc(z1,z2)
     &         + (cosw * gw + g1 * sinw) * dotrc(pwp,wm) * dotcc(z1,z2)
     &         - cosw * gw * dotrc(pwp,z2) * dotcc(z1,wm)
     &         - g1 * sinw * dotrc(pwp,z2) * dotcc(z1,wm)
     &         + cosw * gw * dotrc(pwm,z2) * dotcc(z1,wm)
     &         + g1 * sinw * dotrc(pwm,z2) * dotcc(z1,wm)
     &         - cosw * gw * dotrc(pz2,z1) * dotcc(z2,wm)
     &         - cosw * gw * dotrc(pwm,z1) * dotcc(z2,wm)
     &         - g1 * sinw * dotrc(pwm,z1) * dotcc(z2,wm) ) * gw
     &   + cosw * g1 * sinw * dotrc(pz1,z2) * dotrc(pwp,z1) * dotcc(wp,wm) * gw
     &   + cosw * g1 * sinw * dotrc(pz2,z1) * dotrc(pwp,z2) * dotcc(wp,wm) * gw
     &   + cosw * g1 * sinw * dotrc(pz1,z2) * dotrc(pwm,z1) * dotcc(wp,wm) * gw
     &   + 2. * cosw * g1 * sinw * dotrc(pwp,z2) * dotrc(pwm,z1) * dotcc(wp,wm) * gw
     &   + cosw * g1 * sinw * dotrc(pz2,z1) * dotrc(pwm,z2) * dotcc(wp,wm) * gw
     &   + 2. * cosw * g1 * sinw * dotrc(pwp,z1) * dotrc(pwm,z2) * dotcc(wp,wm) * gw
     &   + cosw * g1 * sinw * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz1,pwp) * gw
     &   - cosw * g1 * sinw * dotcc(z1,z2) * dotcc(wp,wm) * dotrr(pz1,pwp) * gw
     &   + cosw * g1 * sinw * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pz1,pwm) * gw
     &   - cosw * g1 * sinw * dotcc(z1,z2) * dotcc(wp,wm) * dotrr(pz1,pwm) * gw
     &   + cosw * g1 * sinw * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pz2,pwp) * gw
     &   - cosw * g1 * sinw * dotcc(z1,z2) * dotcc(wp,wm) * dotrr(pz2,pwp) * gw
     &   + cosw * g1 * sinw * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pz2,pwm) * gw
     &   - cosw * g1 * sinw * dotcc(z1,z2) * dotcc(wp,wm) * dotrr(pz2,pwm) * gw
     &   + 2. * cosw * g1 * sinw * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pwp,pwm) * gw
     &   + 2. * cosw * g1 * sinw * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pwp,pwm) * gw
     &   - g1**2 * sin2w * dotrc(pwp,wm) * dotrc(pwm,z2) * dotcc(z1,wp)
     &   - g1**2 * sin2w * dotrc(pwp,z2) * dotrc(pwm,wp) * dotcc(z1,wm)
     &   - g1**2 * sin2w * dotrc(pwp,wm) * dotrc(pwm,z1) * dotcc(z2,wp)
     &   - g1**2 * sin2w * dotrc(pwp,z1) * dotrc(pwm,wp) * dotcc(z2,wm)
     &   + g1**2 * sin2w * dotrc(pwp,z2) * dotrc(pwm,z1) * dotcc(wp,wm)
     &   + g1**2 * sin2w * dotrc(pwp,z1) * dotrc(pwm,z2) * dotcc(wp,wm)
     &   + g1**2 * sin2w * dotcc(z1,wm) * dotcc(z2,wp) * dotrr(pwp,pwm)
     &   + g1**2 * sin2w * dotcc(z1,wp) * dotcc(z2,wm) * dotrr(pwp,pwm) )
      endif

      if (fwww .ne. 0) then
        wwzz = wwzz - fwww * 3./2. * gw**4 * cos2w * 
     &      ( ( dotrc(pz2,z1)*(dotrc(pwm,z2)+dotrc(pwp,z2)) + dotrc(pz1,z2)*(dotrc(pwm,z1)+dotrc(pwp,z1)) ) * dotcc(wp,wm)
     &      - dotcc(z1,z2) * dotcc(wm,wp) * ( dotrr(pwm,pz1) + dotrr(pwm,pz2) + dotrr(pwp,pz1) + dotrr(pwp,pz2) )
     &      - dotcc(z2,wm) * ( dotrc(pz2,z1)*dotrc(pwm,wp) + dotrc(pwm,z1)*(dotrc(pz1,wp)-dotrc(pz2,wp))
     &                       + dotrc(pwp,z1)*dotrc(pz2,wp) )
     &      - dotcc(z1,wm) * ( dotrc(pz1,z2)*dotrc(pwm,wp) + dotrc(pwp,z2)*dotrc(pz1,wp)
     &                       + dotrc(pwm,z2)*(dotrc(pz2,wp)-dotrc(pz1,wp)) )
     &      - dotcc(z2,wp) * ( dotrc(pz2,z1)*dotrc(pwp,wm) + dotrc(pwp,z1)*(dotrc(pz1,wm)-dotrc(pz2,wm))
     &                       + dotrc(pwm,z1)*dotrc(pz2,wm) )
     &      - dotcc(z1,wp) * ( dotrc(pz1,z2)*dotrc(pwp,wm) + dotrc(pwm,z2)*dotrc(pz1,wm)
     &                       + dotrc(pwp,z2)*(dotrc(pz2,wm)-dotrc(pz1,wm)) )
     &      + dotcc(z1,z2) * ( (dotrc(pz1,wp)+dotrc(pz2,wp))*dotrc(pwp,wm) + dotrc(pwm,wp)*(dotrc(pz1,wm)+dotrc(pz2,wm)) )
     &      + dotcc(z1,wm) * dotcc(z2,wp) * ( dotrr(pwm,pz2) + dotrr(pwp,pz1) )
     &      + dotcc(z1,wp) * dotcc(z2,wm) * ( dotrr(pwm,pz1) + dotrr(pwp,pz2) ) )
      endif

      if (fw .ne. 0) then
        wwzz = wwzz + fw * gw**2 * wmass**2 * ( - 2.*dotcc(z1,z2)*dotcc(wm,wp) + dotcc(z1,wp)*dotcc(z2,wm)
     &      + dotcc(z1,wm)*dotcc(z2,wp) )
      endif

      return
      end



      subroutine wwww_anomal8(wm1,wp1,wm2,wp2, wwww)
c
c This subroutine computes the wwza-vertex with anomalous couplings
c     
      implicit none
      double complex wp1(6),wm1(6),wp2(6),wm2(6),wwww, dotcc, dotrc
      double precision pwp1(0:3),pwm1(0:3),pwp2(0:3),pwm2(0:3), dotrr
      double precision cos2w, g1, cosw, sinw
      integer i
      external dotcc, dotrc, dotrr

#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/an_couplings.inc"   

      cos2w = 1.0d0 - sin2w
      cosw = sqrt(cos2w)
      sinw = sqrt(sin2w)
      g1 = ee / cosw

      pwm1(0) = dble( wm1(5))
      pwm1(1) = dble( wm1(6))
      pwm1(2) = dimag(wm1(6))
      pwm1(3) = dimag(wm1(5))
      pwp1(0) = dble( wp1(5))
      pwp1(1) = dble( wp1(6))
      pwp1(2) = dimag(wp1(6))
      pwp1(3) = dimag(wp1(5))
      pwm2(0) = dble( wm2(5))
      pwm2(1) = dble( wm2(6))
      pwm2(2) = dimag(wm2(6))
      pwm2(3) = dimag(wm2(5))
      pwp2(0) = dble( wp2(5))
      pwp2(1) = dble( wp2(6))
      pwp2(2) = dimag(wp2(6))
      pwp2(3) = dimag(wp2(5))

      wwww = - ee**2 / sin2w * (dotcc(wm1,wp1)*dotcc(wm2,wp2) + dotcc(wm1,wp2)*dotcc(wm2,wp1) 
     &                        - 2.0d0*dotcc(wm1,wm2)*dotcc(wp1,wp2))


      if (fs0 .ne. 0) then
        wwww = wwww + 4. * fs0 * wmass**4 *
     &      dotcc(wp1,wp2) * dotcc(wm1,wm2)
      endif

      if (fs1 .ne. 0) then
        wwww = wwww + 2. * fs1 * wmass**4 *
     &      (dotcc(wp1,wm2) * dotcc(wp2,wm1)
     &      + dotcc(wp1,wm1) * dotcc(wp2,wm2))
      endif

      if (ft0 .ne. 0) then
        wwww = wwww + 8. * ft0 * gw**4 *
     &      ( dotrc(pwp1,wm2) * dotrc(pwp2,wm1) * dotrc(pwm1,wp2) * dotrc(pwm2,wp1)
     &      - dotrc(pwp1,wm2) * dotcc(wp2,wm1) * dotrr(pwp2,pwm1) * dotrc(pwm2,wp1)
     &      + dotrc(pwp1,wm1) * dotrc(pwp2,wm2) * dotrc(pwm1,wp1) * dotrc(pwm2,wp2)
     &      - dotrc(pwp2,wm2) * dotrc(pwm2,wp2) * dotcc(wp1,wm1) * dotrr(pwp1,pwm1)
     &      - dotrc(pwp2,wm1) * dotrc(pwm1,wp2) * dotcc(wp1,wm2) * dotrr(pwp1,pwm2)
     &      + dotcc(wp1,wm2) * dotcc(wp2,wm1) * dotrr(pwp1,pwm2) * dotrr(pwp2,pwm1)
     &      - dotrc(pwp1,wm1) * dotrc(pwm1,wp1) * dotcc(wp2,wm2) * dotrr(pwp2,pwm2)
     &      + dotcc(wp1,wm1) * dotcc(wp2,wm2) * dotrr(pwp1,pwm1) * dotrr(pwp2,pwm2))
      endif

      if (ft1 .ne. 0) then
        wwww = wwww + 4. * ft1 * gw**4 *
     &      ( dotrc(pwp1,wm2) * dotrc(pwp2,wm1) * dotrc(pwm1,wp2) * dotrc(pwm2,wp1)
     &      - dotrc(pwp1,wm2) * dotcc(wp2,wm1) * dotrr(pwp2,pwm1) * dotrc(pwm2,wp1)
     &      + dotrc(pwp1,wm1) * dotrc(pwp2,wm2) * dotrc(pwm1,wp1) * dotrc(pwm2,wp2)
     &      + 2. * dotrc(pwp1,wp2) * dotrc(pwp2,wp1) * dotrc(pwm1,wm2) * dotrc(pwm2,wm1)
     &      - 2. * dotrc(pwm1,wm2) * dotrc(pwm2,wm1) * dotcc(wp1,wp2) * dotrr(pwp1,pwp2)
     &      - dotrc(pwp2,wm2) * dotrc(pwm2,wp2) * dotcc(wp1,wm1) * dotrr(pwp1,pwm1)
     &      - dotrc(pwp2,wm1) * dotrc(pwm1,wp2) * dotcc(wp1,wm2) * dotrr(pwp1,pwm2)
     &      + dotcc(wp1,wm2) * dotcc(wp2,wm1) * dotrr(pwp1,pwm2) * dotrr(pwp2,pwm1)
     &      - dotrc(pwp1,wm1) * dotrc(pwm1,wp1) * dotcc(wp2,wm2) * dotrr(pwp2,pwm2)
     &      + dotcc(wp1,wm1) * dotcc(wp2,wm2) * dotrr(pwp1,pwm1) * dotrr(pwp2,pwm2)
     &      - 2. * dotrc(pwp1,wp2) * dotrc(pwp2,wp1) * dotcc(wm1,wm2) * dotrr(pwm1,pwm2)
     &      + 2. * dotcc(wp1,wp2) * dotcc(wm1,wm2) * dotrr(pwp1,pwp2) * dotrr(pwm1,pwm2))
      endif

      if (ft2 .ne. 0) then
        wwww = wwww + ft2 * gw**4 *
     &      ( 2. * dotrc(pwp1,wm1) * dotrc(pwp2,wm2) * dotrc(pwm1,wp2) * dotrc(pwm2,wp1)
     &      + dotrc(pwp1,wp2) * dotrc(pwp2,wm1) * dotrc(pwm1,wm2) * dotrc(pwm2,wp1)
     &      - dotrc(pwm1,wm2) * dotcc(wp2,wm1) * dotrr(pwp1,pwp2) * dotrc(pwm2,wp1)
     &      + dotrc(pwm1,wp2) * dotcc(wm1,wm2) * dotrr(pwp1,pwp2) * dotrc(pwm2,wp1)
     &      - 2. * dotrc(pwp2,wm2) * dotcc(wp2,wm1) * dotrr(pwp1,pwm1) * dotrc(pwm2,wp1)
     &      + 2. * dotrc(pwp2,wm1) * dotcc(wp2,wm2) * dotrr(pwp1,pwm1) * dotrc(pwm2,wp1)
     &      - 2. * dotrc(pwp1,wm1) * dotcc(wp2,wm2) * dotrr(pwp2,pwm1) * dotrc(pwm2,wp1)
     &      - dotrc(pwp1,wp2) * dotcc(wm1,wm2) * dotrr(pwp2,pwm1) * dotrc(pwm2,wp1)
     &      + 2. * dotrc(pwp1,wm2) * dotrc(pwp2,wm1) * dotrc(pwm1,wp1) * dotrc(pwm2,wp2)
     &      + dotrc(pwp1,wm1) * dotrc(pwp2,wp1) * dotrc(pwm1,wm2) * dotrc(pwm2,wp2)
     &      + dotrc(pwp1,wp2) * dotrc(pwp2,wm2) * dotrc(pwm1,wp1) * dotrc(pwm2,wm1)
     &      + dotrc(pwp1,wm2) * dotrc(pwp2,wp1) * dotrc(pwm1,wp2) * dotrc(pwm2,wm1)
     &      - dotrc(pwm1,wm2) * dotrc(pwm2,wp2) * dotcc(wp1,wm1) * dotrr(pwp1,pwp2)
     &      - dotrc(pwm1,wp2) * dotrc(pwm2,wm1) * dotcc(wp1,wm2) * dotrr(pwp1,pwp2)
     &      - dotrc(pwm1,wp1) * dotrc(pwm2,wm1) * dotcc(wp2,wm2) * dotrr(pwp1,pwp2)
     &      + dotrc(pwm1,wp1) * dotrc(pwm2,wp2) * dotcc(wm1,wm2) * dotrr(pwp1,pwp2)
     &      - dotrc(pwp2,wm2) * dotrc(pwm2,wm1) * dotcc(wp1,wp2) * dotrr(pwp1,pwm1)
     &      - 2. * dotrc(pwp2,wm1) * dotrc(pwm2,wp2) * dotcc(wp1,wm2) * dotrr(pwp1,pwm1)
     &      + dotrc(pwp2,wp1) * dotrc(pwm2,wm1) * dotcc(wp2,wm2) * dotrr(pwp1,pwm1)
     &      - dotrc(pwp2,wp1) * dotrc(pwm2,wp2) * dotcc(wm1,wm2) * dotrr(pwp1,pwm1)
     &      - dotrc(pwp2,wm1) * dotrc(pwm1,wm2) * dotcc(wp1,wp2) * dotrr(pwp1,pwm2)
     &      - 2. * dotrc(pwp2,wm2) * dotrc(pwm1,wp2) * dotcc(wp1,wm1) * dotrr(pwp1,pwm2)
     &      + 2. * dotrc(pwp2,wm2) * dotrc(pwm1,wp1) * dotcc(wp2,wm1) * dotrr(pwp1,pwm2)
     &      + dotrc(pwp2,wp1) * dotrc(pwm1,wm2) * dotcc(wp2,wm1) * dotrr(pwp1,pwm2)
     &      - 2. * dotrc(pwp2,wm1) * dotrc(pwm1,wp1) * dotcc(wp2,wm2) * dotrr(pwp1,pwm2)
     &      - dotrc(pwp2,wp1) * dotrc(pwm1,wp2) * dotcc(wm1,wm2) * dotrr(pwp1,pwm2)
     &      - dotrc(pwp1,wm2) * dotrc(pwm2,wm1) * dotcc(wp1,wp2) * dotrr(pwp2,pwm1)
     &      - 2. * dotrc(pwp1,wm2) * dotrc(pwm2,wp2) * dotcc(wp1,wm1) * dotrr(pwp2,pwm1)
     &      + 2. * dotrc(pwp1,wm1) * dotrc(pwm2,wp2) * dotcc(wp1,wm2) * dotrr(pwp2,pwm1)
     &      + dotrc(pwp1,wp2) * dotrc(pwm2,wm1) * dotcc(wp1,wm2) * dotrr(pwp2,pwm1)
     &      + 2. * dotcc(wp1,wm1) * dotcc(wp2,wm2) * dotrr(pwp1,pwm2) * dotrr(pwp2,pwm1)
     &      + dotcc(wp1,wp2) * dotcc(wm1,wm2) * dotrr(pwp1,pwm2) * dotrr(pwp2,pwm1)
     &      - dotrc(pwp1,wm1) * dotrc(pwm1,wm2) * dotcc(wp1,wp2) * dotrr(pwp2,pwm2)
     &      + 2. * dotrc(pwp1,wm2) * dotrc(pwm1,wp2) * dotcc(wp1,wm1) * dotrr(pwp2,pwm2)
     &      + dotrc(pwp1,wp2) * dotrc(pwm1,wm2) * dotcc(wp1,wm1) * dotrr(pwp2,pwm2)
     &      - 2. * dotrc(pwp1,wm1) * dotrc(pwm1,wp2) * dotcc(wp1,wm2) * dotrr(pwp2,pwm2)
     &      - 2. * dotrc(pwp1,wm2) * dotrc(pwm1,wp1) * dotcc(wp2,wm1) * dotrr(pwp2,pwm2)
     &      - dotrc(pwp1,wp2) * dotrc(pwm1,wp1) * dotcc(wm1,wm2) * dotrr(pwp2,pwm2)
     &      + 2. * dotcc(wp1,wm2) * dotcc(wp2,wm1) * dotrr(pwp1,pwm1) * dotrr(pwp2,pwm2)
     &      + dotcc(wp1,wp2) * dotcc(wm1,wm2) * dotrr(pwp1,pwm1) * dotrr(pwp2,pwm2)
     &      + dotrc(pwp1,wm2) * dotrc(pwp2,wm1) * dotcc(wp1,wp2) * dotrr(pwm1,pwm2)
     &      + dotrc(pwp1,wm1) * dotrc(pwp2,wm2) * dotcc(wp1,wp2) * dotrr(pwm1,pwm2)
     &      - dotrc(pwp1,wp2) * dotrc(pwp2,wm2) * dotcc(wp1,wm1) * dotrr(pwm1,pwm2)
     &      - dotrc(pwp1,wp2) * dotrc(pwp2,wm1) * dotcc(wp1,wm2) * dotrr(pwm1,pwm2)
     &      - dotrc(pwp1,wm2) * dotrc(pwp2,wp1) * dotcc(wp2,wm1) * dotrr(pwm1,pwm2)
     &      - dotrc(pwp1,wm1) * dotrc(pwp2,wp1) * dotcc(wp2,wm2) * dotrr(pwm1,pwm2)
     &      + dotcc(wp1,wm2) * dotcc(wp2,wm1) * dotrr(pwp1,pwp2) * dotrr(pwm1,pwm2)
     &      + dotcc(wp1,wm1) * dotcc(wp2,wm2) * dotrr(pwp1,pwp2) * dotrr(pwm1,pwm2))
      endif

      if (fm0 .ne. 0) then
        wwww = wwww - fm0 * gw**2 * wmass**2 * 2. *
     &      ( dotrc(pwp2,wm2) * dotrc(pwm2,wp2) * dotcc(wp1,wm1)
     &      - dotcc(wp2,wm2) * dotrr(pwp1,pwm1) * dotcc(wp1,wm1)
     &      - dotcc(wp2,wm2) * dotrr(pwp2,pwm2) * dotcc(wp1,wm1)
     &      + dotrc(pwm1,wp2) * dotrc(pwp2,wm1) * dotcc(wp1,wm2)
     &      + dotrc(pwp1,wm2) * dotrc(pwm2,wp1) * dotcc(wm1,wp2)
     &      + dotrc(pwp1,wm1) * dotrc(pwm1,wp1) * dotcc(wp2,wm2)
     &      - dotcc(wp1,wm2) * dotcc(wm1,wp2) * dotrr(pwp1,pwm2)
     &      - dotcc(wp1,wm2) * dotcc(wm1,wp2) * dotrr(pwm1,pwp2))
      endif

      if (fm1 .ne. 0) then
c        wwww = wwww - fm1 * gw**4 * v**2 / 8. *
        wwww = wwww - fm1 * gw**2 * wmass**2 / 2. *
     &      ( dotrc(pwp1,wm2) * dotrc(pwm1,wp2) * dotcc(wp1,wm1)
     &      + dotrc(pwp1,wp2) * dotrc(pwm1,wm2) * dotcc(wp1,wm1)
     &      - dotrc(pwm1,wp2) * dotrc(pwp2,wm2) * dotcc(wp1,wm1)
     &      - dotrc(pwp1,wm2) * dotrc(pwm2,wp2) * dotcc(wp1,wm1)
     &      + dotcc(wp2,wm2) * dotrr(pwp1,pwm2) * dotcc(wp1,wm1)
     &      + dotcc(wp2,wm2) * dotrr(pwm1,pwp2) * dotcc(wp1,wm1)
     &      - dotrc(pwp1,wm1) * dotrc(pwm1,wm2) * dotcc(wp1,wp2)
     &      - dotrc(pwm1,wm2) * dotrc(pwp2,wm1) * dotcc(wp1,wp2)
     &      - dotrc(pwp1,wm2) * dotrc(pwm2,wm1) * dotcc(wp1,wp2)
     &      - dotrc(pwp2,wm2) * dotrc(pwm2,wm1) * dotcc(wp1,wp2)
     &      - dotrc(pwp1,wm1) * dotrc(pwm1,wp2) * dotcc(wp1,wm2)
     &      + dotrc(pwp1,wp2) * dotrc(pwm2,wm1) * dotcc(wp1,wm2)
     &      + dotrc(pwp1,wm1) * dotrc(pwm2,wp2) * dotcc(wp1,wm2)
     &      - dotrc(pwp2,wm1) * dotrc(pwm2,wp2) * dotcc(wp1,wm2)
     &      - dotrc(pwp1,wm2) * dotrc(pwm1,wp1) * dotcc(wm1,wp2)
     &      + dotrc(pwm1,wm2) * dotrc(pwp2,wp1) * dotcc(wm1,wp2)
     &      + dotrc(pwm1,wp1) * dotrc(pwp2,wm2) * dotcc(wm1,wp2)
     &      - dotrc(pwp2,wm2) * dotrc(pwm2,wp1) * dotcc(wm1,wp2)
     &      - dotrc(pwp1,wp2) * dotrc(pwm1,wp1) * dotcc(wm1,wm2)
     &      - dotrc(pwm1,wp2) * dotrc(pwp2,wp1) * dotcc(wm1,wm2)
     &      - dotrc(pwp1,wp2) * dotrc(pwm2,wp1) * dotcc(wm1,wm2)
     &      - dotrc(pwp2,wp1) * dotrc(pwm2,wp2) * dotcc(wm1,wm2)
     &      - dotrc(pwm1,wp1) * dotrc(pwp2,wm1) * dotcc(wp2,wm2)
     &      - dotrc(pwp1,wm1) * dotrc(pwm2,wp1) * dotcc(wp2,wm2)
     &      + dotrc(pwp2,wm1) * dotrc(pwm2,wp1) * dotcc(wp2,wm2)
     &      + dotrc(pwp2,wp1) * dotrc(pwm2,wm1) * dotcc(wp2,wm2)
     &      + dotcc(wp1,wm2) * dotcc(wm1,wp2) * dotrr(pwp1,pwm1)
     &      + dotcc(wp1,wp2) * dotcc(wm1,wm2) * dotrr(pwp1,pwm1)
     &      + dotcc(wp1,wp2) * dotcc(wm1,wm2) * dotrr(pwp1,pwm2)
     &      + dotcc(wp1,wp2) * dotcc(wm1,wm2) * dotrr(pwm1,pwp2)
     &      + dotcc(wp1,wm2) * dotcc(wm1,wp2) * dotrr(pwp2,pwm2)
     &      + dotcc(wp1,wp2) * dotcc(wm1,wm2) * dotrr(pwp2,pwm2))
      endif

      if (fm6 .ne. 0) then
        wwww = wwww - fm6 * gw**2 * wmass**2 *
     &      ( dotrc(pwp2,wm2) * dotrc(pwm2,wp2) * dotcc(wp1,wm1)
     &      - dotcc(wp2,wm2) * dotrr(pwp1,pwm1) * dotcc(wp1,wm1)
     &      - dotcc(wp2,wm2) * dotrr(pwp2,pwm2) * dotcc(wp1,wm1)
     &      + dotrc(pwm1,wp2) * dotrc(pwp2,wm1) * dotcc(wp1,wm2)
     &      + dotrc(pwp1,wm2) * dotrc(pwm2,wp1) * dotcc(wm1,wp2)
     &      + dotrc(pwp1,wm1) * dotrc(pwm1,wp1) * dotcc(wp2,wm2)
     &      - dotcc(wp1,wm2) * dotcc(wm1,wp2) * dotrr(pwp1,pwm2)
     &      - dotcc(wp1,wm2) * dotcc(wm1,wp2) * dotrr(pwm1,pwp2))
      endif

      if (fm7 .ne. 0) then
        wwww = wwww + fm7 * gw**2 * wmass**2 / 2. *
     &      ( dotrc(pwp1,wp2) * dotrc(pwm1,wm2) * dotcc(wp1,wm1)
     &      - dotrc(pwp1,wm1) * dotrc(pwm1,wm2) * dotcc(wp1,wp2)
     &      - dotrc(pwm1,wm2) * dotrc(pwp2,wm1) * dotcc(wp1,wp2)
     &      - dotrc(pwp1,wm2) * dotrc(pwm2,wm1) * dotcc(wp1,wp2)
     &      - dotrc(pwp2,wm2) * dotrc(pwm2,wm1) * dotcc(wp1,wp2)
     &      + dotrc(pwp1,wp2) * dotrc(pwm2,wm1) * dotcc(wp1,wm2)
     &      + dotrc(pwm1,wm2) * dotrc(pwp2,wp1) * dotcc(wm1,wp2)
     &      - dotrc(pwp1,wp2) * dotrc(pwm1,wp1) * dotcc(wm1,wm2)
     &      - dotrc(pwm1,wp2) * dotrc(pwp2,wp1) * dotcc(wm1,wm2)
     &      - dotrc(pwp1,wp2) * dotrc(pwm2,wp1) * dotcc(wm1,wm2)
     &      - dotrc(pwp2,wp1) * dotrc(pwm2,wp2) * dotcc(wm1,wm2)
     &      + dotrc(pwp2,wp1) * dotrc(pwm2,wm1) * dotcc(wp2,wm2)
     &      + dotcc(wp1,wp2) * dotcc(wm1,wm2) * dotrr(pwp1,pwm1)
     &      + dotcc(wp1,wp2) * dotcc(wm1,wm2) * dotrr(pwp1,pwm2)
     &      + dotcc(wp1,wp2) * dotcc(wm1,wm2) * dotrr(pwm1,pwp2)
     &      + dotcc(wp1,wp2) * dotcc(wm1,wm2) * dotrr(pwp2,pwm2))
      endif

      if (fwww .ne. 0) then
        wwww = wwww - fwww * 3./2. * gw**4 * 
     &      ( ( dotrc(pwm2,wp1) * (dotrc(pwp1,wm1) - dotrc(pwp2,wm1)) + dotrc(pwm1,wp1) * dotrc(pwp2,wm1)
     &            + dotrc(pwp2,wp1) * dotrc(pwm2,wm1) ) * dotcc(wp2,wm2)
     &      - dotcc(wp1,wm1) * dotcc(wp2,wm2) * (dotrr(pwp1,pwm2) + dotrr(pwm1,pwp2))
     &      + dotcc(wp1,wm2) * ( dotrc(pwm2,wm1) * dotrc(pwp1,wp2) + dotrc(pwp1,wm1) *
     &         (dotrc(pwm1,wp2) - dotrc(pwm2,wp2)) + dotrc(pwp2,wm1) * dotrc(pwm2,wp2) )
     &      - dotcc(wm1,wm2) * ( (dotrc(pwm1,wp1) + dotrc(pwm2,wp1)) * dotrc(pwp1,wp2)
     &         + dotrc(pwp2,wp1) * (dotrc(pwm1,wp2) + dotrc(pwm2,wp2)) )
     &      + dotcc(wm1,wp2) * ( dotrc(pwp2,wp1) * dotrc(pwm1,wm2) + dotrc(pwm1,wp1) *
     &         (dotrc(pwp1,wm2) - dotrc(pwp2,wm2)) + dotrc(pwm2,wp1) * dotrc(pwp2,wm2) )
     &      + dotcc(wp1,wm1) * ( dotrc(pwm2,wp2) * dotrc(pwp1,wm2) + dotrc(pwp1,wp2) * dotrc(pwm1,wm2)
     &         + dotrc(pwm1,wp2) * (dotrc(pwp2,wm2) - dotrc(pwp1,wm2)) )
     &      - dotcc(wp1,wp2) * ( (dotrc(pwp1,wm1) + dotrc(pwp2,wm1)) * dotrc(pwm1,wm2)
     &         + dotrc(pwm2,wm1) * (dotrc(pwp1,wm2) + dotrc(pwp2,wm2)) )
     &      - dotcc(wp1,wm2) * dotcc(wm1,wp2) * (dotrr(pwp1,pwm1) + dotrr(pwp2,pwm2))
     &      + dotcc(wp1,wp2) * dotcc(wm1,wm2) * ( dotrr(pwp1,pwm1) + dotrr(pwp1,pwm2)
     &         + dotrr(pwm1,pwp2) + dotrr(pwp2,pwm2) ) )
      endif

      if (fw .ne. 0) then
        wwww = wwww + fw * gw**2 * wmass**2 * ( 2.*dotcc(wp1,wp2)*dotcc(wm1,wm2) - dotcc(wp1,wm1)*dotcc(wp2,wm2)
     &      - dotcc(wp1,wm2)*dotcc(wp2,wm1) )
      endif

      return
      end


********************************************************************************
********************************************************************************

** This subroutine applies the formfactor for the dim-8 operators for anomalous
** gauge boson couplings.
** Input via anomV.dat.
** Also applies formfactors to dim-6 operators -the coefficients FB, FW and 
** FWWW (which parametrise the WWZ and WWgamma couplings) can have individual 
** formfactors

      subroutine anomal_formfactor_4v(p)

      implicit none

#include "VBFNLO/utilities/an_couplings.inc"
*#include "VBFNLO/utilities/coupl.inc"
#include "VBFNLO/utilities/mssm.inc"

      real*8 p(0:3),s

      double precision ffvalue, ffvalue_fwww, ffvalue_fw, ffvalue_fb


      if (formfact) then
        s=(p(0))**2-(p(1))**2-(p(2))**2-(p(3))**2

** 'universal' formfactors:
        ffvalue=(1./(1.+s/ffmassscale2))**DBLE(ffexponent)

** individual formfactors for dim-6 operators
        if (formfac_ind) then
           ffvalue_fwww = (1./(1. + s/massscale2FWWW))**DBLE(ffexpFWWW)
           ffvalue_fw = (1./(1. + s/massscale2FW))**DBLE(ffexpFW)
           if (trianom .eq. 1) then
              ffvalue_fb = (1./(1. + s/massscale2FB))**DBLE(ffexpFB)
           else if (fb_0 .ne. 0d0) then
c$$$              ffvalue_fb = CW2*MZ2*fw_0*ffvalue_fw - 
c$$$     &             2d0*zDkappa0_0/((1D0 + s/massscale2KZ)**ffexpKZ)
c$$$              ffvale_fb = ffvalue_fb/(CW2*MZ2*fw_0 - 2d0*zDkappa0_0)
              ffvalue_fb = 2d0*aDkappa0_0/(1d0 + s/
     &             massscale2KA)**dble(ffexpKA) - MW2*fw_0*ffvalue_fw
              ffvalue_fb = ffvalue_fb/(2d0*aDkappa0_0 - MW2*fw_0)
           else
              ffvalue_fb = 1d0
           end if
        else
           ffvalue_fb = ffvalue
           ffvalue_fw = ffvalue
           ffvalue_fwww = ffvalue
        end if

c        if (sqrt(s).gt.ffmassscale) then
c          ffvalue=0
c        else
c          ffvalue=1
c        endif
c        print *,sqrt(s), ", ", ffvalue

** dim-8 operators:
        fs0=fs0_0*ffvalue
        fs1=fs1_0*ffvalue
        ft0=ft0_0*ffvalue
        ft1=ft1_0*ffvalue
        ft2=ft2_0*ffvalue
        ft5=ft5_0*ffvalue
        ft6=ft6_0*ffvalue
        ft7=ft7_0*ffvalue
        fm0=fm0_0*ffvalue
        fm1=fm1_0*ffvalue
        fm2=fm2_0*ffvalue
        fm3=fm3_0*ffvalue
        fm4=fm4_0*ffvalue
        fm5=fm5_0*ffvalue
        fm6=fm6_0*ffvalue
        fm7=fm7_0*ffvalue

** dim-6 opertators:
        fwww = fwww_0*ffvalue_fwww
        fw = fw_0*ffvalue_fw
        fb = fb_0*ffvalue_fb

      endif


c$$$      write(*,*)'s =', s
c$$$      write(*,*)'ffvalue, ffvalue_fwww =', ffvalue, ffvalue_fwww
c$$$      write(*,*)'ffvalue_fb, ffvalue_fw =', ffvalue_fb, ffvalue_fw
c$$$      write(*,*)'ffmassscale2, ffexponent', ffmassscale2,ffexponent
c$$$      write(*,*)'FWWW: massscale2, ffexp =', massscale2FWWW, ffexpFWWW
c$$$      write(*,*)'FW: massscale2, ffexp =', massscale2FW, ffexpFW
c$$$      write(*,*)'FB: massscale2, ffexp =', massscale2FB, ffexpFB
c$$$      write(*,*)'fwww, fwww_0 =', fwww, fwww_0
c$$$      write(*,*)'fw, fw_0 =', fw, fw_0
c$$$      write(*,*)'fb, fb_0 =', fb, fb_0
c$$$      stop


      end
